/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:3,flag:"",revision:Number("$Rev: 8617 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}else{
_12=dojo.errorToString(_12);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"||(djConfig["useXDomain"]&&dojo.render.html.opera)){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
if(djConfig["modulePaths"]){
for(var param in djConfig["modulePaths"]){
dojo.registerModulePath(param,djConfig["modulePaths"][param]);
}
}
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
var _6f=_6e?_6e.toLowerCase():dojo.locale;
if(_6f=="root"){
_6f="ROOT";
}
return _6f;
};
dojo.hostenv.searchLocalePath=function(_70,_71,_72){
_70=dojo.hostenv.normalizeLocale(_70);
var _73=_70.split("-");
var _74=[];
for(var i=_73.length;i>0;i--){
_74.push(_73.slice(0,i).join("-"));
}
_74.push(false);
if(_71){
_74.reverse();
}
for(var j=_74.length-1;j>=0;j--){
var loc=_74[j]||"ROOT";
var _78=_72(loc);
if(_78){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_79){
_79=dojo.hostenv.normalizeLocale(_79);
dojo.hostenv.searchLocalePath(_79,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7c=djConfig.extraLocale||[];
for(var i=0;i<_7c.length;i++){
preload(_7c[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7e,_7f,_80,_81){
dojo.hostenv.preloadLocalizations();
var _82=dojo.hostenv.normalizeLocale(_80);
var _83=[_7e,"nls",_7f].join(".");
var _84="";
if(_81){
var _85=_81.split(",");
for(var i=0;i<_85.length;i++){
if(_82.indexOf(_85[i])==0){
if(_85[i].length>_84.length){
_84=_85[i];
}
}
}
if(!_84){
_84="ROOT";
}
}
var _87=_81?_84:_82;
var _88=dojo.hostenv.findModule(_83);
var _89=null;
if(_88){
if(djConfig.localizationComplete&&_88._built){
return;
}
var _8a=_87.replace("-","_");
var _8b=_83+"."+_8a;
_89=dojo.hostenv.findModule(_8b);
}
if(!_89){
_88=dojo.hostenv.startPackage(_83);
var _8c=dojo.hostenv.getModuleSymbols(_7e);
var _8d=_8c.concat("nls").join("/");
var _8e;
dojo.hostenv.searchLocalePath(_87,_81,function(loc){
var _90=loc.replace("-","_");
var _91=_83+"."+_90;
var _92=false;
if(!dojo.hostenv.findModule(_91)){
dojo.hostenv.startPackage(_91);
var _93=[_8d];
if(loc!="ROOT"){
_93.push(loc);
}
_93.push(_7f);
var _94=_93.join("/")+".js";
_92=dojo.hostenv.loadPath(_94,null,function(_95){
var _96=function(){
};
_96.prototype=_8e;
_88[_90]=new _96();
for(var j in _95){
_88[_90][j]=_95[j];
}
});
}else{
_92=true;
}
if(_92&&_88[_90]){
_8e=_88[_90];
}else{
_88[_90]=_8e;
}
if(_81){
return true;
}
});
}
if(_81&&_82!=_84){
_88[_82.replace("-","_")]=_88[_84.replace("-","_")];
}
};
(function(){
var _98=djConfig.extraLocale;
if(_98){
if(!_98 instanceof Array){
_98=[_98];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_9c,_9d){
req(m,b,_9c,_9d);
if(_9c){
return;
}
for(var i=0;i<_98.length;i++){
req(m,b,_98[i],_9d);
}
};
}
})();
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _9f=document.location.toString();
var _a0=_9f.split("?",2);
if(_a0.length>1){
var _a1=_a0[1];
var _a2=_a1.split("&");
for(var x in _a2){
var sp=_a2[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _a6=document.getElementsByTagName("script");
var _a7=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_a6.length;i++){
var src=_a6[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_a7);
if(m){
var _ab=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
_ab+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=_ab;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=_ab;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _b3=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_b3>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_b3+6,_b3+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var _b5=window["document"];
var tdi=_b5["implementation"];
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}else{
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var _b9=null;
var _ba=null;
try{
_b9=new XMLHttpRequest();
}
catch(e){
}
if(!_b9){
for(var i=0;i<3;++i){
var _bc=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
_b9=new ActiveXObject(_bc);
}
catch(e){
_ba=e;
}
if(_b9){
dojo.hostenv._XMLHTTP_PROGIDS=[_bc];
break;
}
}
}
if(!_b9){
return dojo.raise("XMLHTTP not available",_ba);
}
return _b9;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_be,_bf){
if(!_be){
this._blockAsync=true;
}
var _c0=this.getXmlhttpObject();
function isDocumentOk(_c1){
var _c2=_c1["status"];
return Boolean((!_c2)||((200<=_c2)&&(300>_c2))||(_c2==304));
}
if(_be){
var _c3=this,_c4=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
_c0.onreadystatechange=function(){
if(_c4){
gbl.clearTimeout(_c4);
_c4=null;
}
if(_c3._blockAsync||(xhr&&xhr._blockAsync)){
_c4=gbl.setTimeout(function(){
_c0.onreadystatechange.apply(this);
},10);
}else{
if(4==_c0.readyState){
if(isDocumentOk(_c0)){
_be(_c0.responseText);
}
}
}
};
}
_c0.open("GET",uri,_be?true:false);
try{
_c0.send(null);
if(_be){
return null;
}
if(!isDocumentOk(_c0)){
var err=Error("Unable to load "+uri+" status:"+_c0.status);
err.status=_c0.status;
err.responseText=_c0.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_bf)&&(!_be)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return _c0.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(_c8){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(_c8);
}else{
try{
var _c9=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_c9){
_c9=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(_c8));
_c9.appendChild(div);
}
catch(e){
try{
document.write("<div>"+_c8+"</div>");
}
catch(e2){
window.status=_c8;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(_cb,_cc,fp){
var _ce=_cb["on"+_cc]||function(){
};
_cb["on"+_cc]=function(){
fp.apply(_cb,arguments);
_ce.apply(_cb,arguments);
};
return true;
}
dojo.hostenv._djInitFired=false;
function dj_load_init(e){
dojo.hostenv._djInitFired=true;
var _d0=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(_d0!="domcontentloaded"&&_d0!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _d1=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_d1();
dojo.hostenv.modulesLoaded();
}else{
dojo.hostenv.modulesLoadedListeners.unshift(_d1);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&(djConfig["enableMozDomContentLoaded"]===true))){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var _d3=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
_d3=_d3.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
_d3=_d3.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(_d3.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _d4=new dojo.xml.Parse();
if(_d3.length>0){
for(var x=0;x<_d3.length;x++){
var _d6=document.getElementById(_d3[x]);
if(!_d6){
continue;
}
var _d7=_d4.parseElement(_d6,null,true);
dojo.widget.getParser().createComponents(_d7);
}
}else{
if(djConfig.parseWidgets){
var _d7=_d4.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(_d7);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_dc,_dd){
dj_currentContext=_dc;
dj_currentDocument=_dd;
};
dojo._fireCallback=function(_de,_df,_e0){
if((_df)&&((typeof _de=="string")||(_de instanceof String))){
_de=_df[_de];
}
return (_df?_de.apply(_df,_e0||[]):_de());
};
dojo.withGlobal=function(_e1,_e2,_e3,_e4){
var _e5;
var _e6=dj_currentContext;
var _e7=dj_currentDocument;
try{
dojo.setContext(_e1,_e1.document);
_e5=dojo._fireCallback(_e2,_e3,_e4);
}
finally{
dojo.setContext(_e6,_e7);
}
return _e5;
};
dojo.withDoc=function(_e8,_e9,_ea,_eb){
var _ec;
var _ed=dj_currentDocument;
try{
dj_currentDocument=_e8;
_ec=dojo._fireCallback(_e9,_ea,_eb);
}
finally{
dj_currentDocument=_ed;
}
return _ec;
};
}
dojo.requireIf((djConfig["isDebug"]||djConfig["debugAtAllCosts"]),"dojo.debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&!djConfig["useXDomain"],"dojo.browser_debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&djConfig["useXDomain"],"dojo.browser_debug_xd");
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_ee,_ef){
if(!dojo.lang.isFunction(_ef)){
dojo.raise("dojo.inherits: superclass argument ["+_ef+"] must be a function (subclass: ["+_ee+"']");
}
_ee.prototype=new _ef();
_ee.prototype.constructor=_ee;
_ee.superclass=_ef.prototype;
_ee["super"]=_ef.prototype;
};
dojo.lang._mixin=function(obj,_f1){
var _f2={};
for(var x in _f1){
if((typeof _f2[x]=="undefined")||(_f2[x]!=_f1[x])){
obj[x]=_f1[x];
}
}
if(dojo.render.html.ie&&(typeof (_f1["toString"])=="function")&&(_f1["toString"]!=obj["toString"])&&(_f1["toString"]!=_f2["toString"])){
obj.toString=_f1.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_f5){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_f8,_f9){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_f8.prototype,arguments[i]);
}
return _f8;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_fc,_fd,_fe,_ff){
if(!dojo.lang.isArrayLike(_fc)&&dojo.lang.isArrayLike(_fd)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_fc;
_fc=_fd;
_fd=temp;
}
var _101=dojo.lang.isString(_fc);
if(_101){
_fc=_fc.split("");
}
if(_ff){
var step=-1;
var i=_fc.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_fc.length;
}
if(_fe){
while(i!=end){
if(_fc[i]===_fd){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_fc[i]==_fd){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_105,_106,_107){
return dojo.lang.find(_105,_106,_107,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_108,_109){
return dojo.lang.find(_108,_109)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
return (it instanceof Function||typeof it=="function");
};
(function(){
if((dojo.render.html.capable)&&(dojo.render.html["safari"])){
dojo.lang.isFunction=function(it){
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
}
})();
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction(it)&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_114,_115){
var args=[];
for(var x=2;x<arguments.length;x++){
args.push(arguments[x]);
}
var fcn=(dojo.lang.isString(_115)?_114[_115]:_115)||function(){
};
return function(){
var ta=args.concat([]);
for(var x=0;x<arguments.length;x++){
ta.push(arguments[x]);
}
return fcn.apply(_114,ta);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_11b,_11c,_11d){
var nso=(_11c||dojo.lang.anon);
if((_11d)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_11b){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_11b;
return ret;
};
dojo.lang.forward=function(_121){
return function(){
return this[_121].apply(this,arguments);
};
};
dojo.lang.curry=function(_122,func){
var _124=[];
_122=_122||dj_global;
if(dojo.lang.isString(func)){
func=_122[func];
}
for(var x=2;x<arguments.length;x++){
_124.push(arguments[x]);
}
var _126=(func["__preJoinArity"]||func.length)-_124.length;
function gather(_127,_128,_129){
var _12a=_129;
var _12b=_128.slice(0);
for(var x=0;x<_127.length;x++){
_12b.push(_127[x]);
}
_129=_129-_127.length;
if(_129<=0){
var res=func.apply(_122,_12b);
_129=_12a;
return res;
}else{
return function(){
return gather(arguments,_12b,_129);
};
}
}
return gather([],_124,_126);
};
dojo.lang.curryArguments=function(_12e,func,args,_131){
var _132=[];
var x=_131||0;
for(x=_131;x<args.length;x++){
_132.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[_12e,func].concat(_132));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_138,_139){
if(!farr.length){
if(typeof _139=="function"){
_139();
}
return;
}
if((typeof _138=="undefined")&&(typeof cb=="number")){
_138=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_138){
_138=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_138,_139);
},_138);
};
dojo.provide("dojo.string.common");
dojo.string.trim=function(str,wh){
if(!str.replace){
return str;
}
if(!str.length){
return str;
}
var re=(wh>0)?(/^\s+/):(wh<0)?(/\s+$/):(/^\s+|\s+$/g);
return str.replace(re,"");
};
dojo.string.trimStart=function(str){
return dojo.string.trim(str,1);
};
dojo.string.trimEnd=function(str){
return dojo.string.trim(str,-1);
};
dojo.string.repeat=function(str,_140,_141){
var out="";
for(var i=0;i<_140;i++){
out+=str;
if(_141&&i<_140-1){
out+=_141;
}
}
return out;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.provide("dojo.lang.array");
dojo.lang.mixin(dojo.lang,{has:function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
},isEmpty:function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _153=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_153++;
break;
}
}
return _153==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
},map:function(arr,obj,_157){
var _158=dojo.lang.isString(arr);
if(_158){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_157)){
_157=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_157){
var _159=obj;
obj=_157;
_157=_159;
}
}
if(Array.map){
var _15a=Array.map(arr,_157,obj);
}else{
var _15a=[];
for(var i=0;i<arr.length;++i){
_15a.push(_157.call(obj,arr[i]));
}
}
if(_158){
return _15a.join("");
}else{
return _15a;
}
},reduce:function(arr,_15d,obj,_15f){
var _160=_15d;
if(arguments.length==2){
_15f=_15d;
_160=arr[0];
arr=arr.slice(1);
}else{
if(arguments.length==3){
if(dojo.lang.isFunction(obj)){
_15f=obj;
obj=null;
}
}else{
if(dojo.lang.isFunction(obj)){
var tmp=_15f;
_15f=obj;
obj=tmp;
}
}
}
var ob=obj||dj_global;
dojo.lang.map(arr,function(val){
_160=_15f.call(ob,_160,val);
});
return _160;
},forEach:function(_164,_165,_166){
if(dojo.lang.isString(_164)){
_164=_164.split("");
}
if(Array.forEach){
Array.forEach(_164,_165,_166);
}else{
if(!_166){
_166=dj_global;
}
for(var i=0,l=_164.length;i<l;i++){
_165.call(_166,_164[i],i,_164);
}
}
},_everyOrSome:function(_169,arr,_16b,_16c){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_169?"every":"some"](arr,_16b,_16c);
}else{
if(!_16c){
_16c=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _16f=_16b.call(_16c,arr[i],i,arr);
if(_169&&!_16f){
return false;
}else{
if((!_169)&&(_16f)){
return true;
}
}
}
return Boolean(_169);
}
},every:function(arr,_171,_172){
return this._everyOrSome(true,arr,_171,_172);
},some:function(arr,_174,_175){
return this._everyOrSome(false,arr,_174,_175);
},filter:function(arr,_177,_178){
var _179=dojo.lang.isString(arr);
if(_179){
arr=arr.split("");
}
var _17a;
if(Array.filter){
_17a=Array.filter(arr,_177,_178);
}else{
if(!_178){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_178=dj_global;
}
_17a=[];
for(var i=0;i<arr.length;i++){
if(_177.call(_178,arr[i],i,arr)){
_17a.push(arr[i]);
}
}
}
if(_179){
return _17a.join("");
}else{
return _17a;
}
},unnest:function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
},toArray:function(_17f,_180){
var _181=[];
for(var i=_180||0;i<_17f.length;i++){
_181.push(_17f[i]);
}
return _181;
}});
dojo.provide("dojo.string.extras");
dojo.string.substituteParams=function(_183,hash){
var map=(typeof hash=="object")?hash:dojo.lang.toArray(arguments,1);
return _183.replace(/\%\{(\w+)\}/g,function(_186,key){
if(typeof (map[key])!="undefined"&&map[key]!=null){
return map[key];
}
dojo.raise("Substitution not found: "+key);
});
};
dojo.string.capitalize=function(str){
if(!dojo.lang.isString(str)){
return "";
}
if(arguments.length==0){
str=this;
}
var _189=str.split(" ");
for(var i=0;i<_189.length;i++){
_189[i]=_189[i].charAt(0).toUpperCase()+_189[i].substring(1);
}
return _189.join(" ");
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _18e=escape(str);
var _18f,re=/%u([0-9A-F]{4})/i;
while((_18f=_18e.match(re))){
var num=Number("0x"+_18f[1]);
var _192=escape("&#"+num+";");
ret+=_18e.substring(0,_18f.index)+_192;
_18e=_18e.substring(_18f.index+_18f[0].length);
}
ret+=_18e.replace(/\+/g,"%2B");
return ret;
};
dojo.string.escape=function(type,str){
var args=dojo.lang.toArray(arguments,1);
switch(type.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,args);
case "sql":
return dojo.string.escapeSql.apply(this,args);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,args);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,args);
case "ascii":
return dojo.string.encodeAscii.apply(this,args);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_197){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_197){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r[\^$|?*+(){}])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}
return str.substring(0,len).replace(/\.+$/,"")+"...";
};
dojo.string.endsWith=function(str,end,_1a0){
if(_1a0){
str=str.toLowerCase();
end=end.toLowerCase();
}
if((str.length-end.length)<0){
return false;
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_1a4,_1a5){
if(_1a5){
str=str.toLowerCase();
_1a4=_1a4.toLowerCase();
}
return str.indexOf(_1a4)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])>-1){
return true;
}
}
return false;
};
dojo.string.normalizeNewlines=function(text,_1ab){
if(_1ab=="\n"){
text=text.replace(/\r\n/g,"\n");
text=text.replace(/\r/g,"\n");
}else{
if(_1ab=="\r"){
text=text.replace(/\r\n/g,"\r");
text=text.replace(/\n/g,"\r");
}else{
text=text.replace(/([^\r])\n/g,"$1\r\n").replace(/\r([^\n])/g,"\r\n$1");
}
}
return text;
};
dojo.string.splitEscaped=function(str,_1ad){
var _1ae=[];
for(var i=0,_1b0=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_1ad){
_1ae.push(str.substring(_1b0,i));
_1b0=i+1;
}
}
_1ae.push(str.substr(_1b0));
return _1ae;
};
dojo.provide("dojo.AdapterRegistry");
dojo.AdapterRegistry=function(_1b1){
this.pairs=[];
this.returnWrappers=_1b1||false;
};
dojo.lang.extend(dojo.AdapterRegistry,{register:function(name,_1b3,wrap,_1b5,_1b6){
var type=(_1b6)?"unshift":"push";
this.pairs[type]([name,_1b3,wrap,_1b5]);
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[1].apply(this,arguments)){
if((pair[3])||(this.returnWrappers)){
return pair[2];
}else{
return pair[2].apply(this,arguments);
}
}
}
throw new Error("No match found");
},unregister:function(name){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[0]==name){
this.pairs.splice(i,1);
return true;
}
}
return false;
}});
dojo.provide("dojo.json");
dojo.json={jsonRegistry:new dojo.AdapterRegistry(),register:function(name,_1be,wrap,_1c0){
dojo.json.jsonRegistry.register(name,_1be,wrap,_1c0);
},evalJson:function(json){
try{
return eval("("+json+")");
}
catch(e){
dojo.debug(e);
return json;
}
},serialize:function(o){
var _1c3=typeof (o);
if(_1c3=="undefined"){
return "undefined";
}else{
if((_1c3=="number")||(_1c3=="boolean")){
return o+"";
}else{
if(o===null){
return "null";
}
}
}
if(_1c3=="string"){
return dojo.string.escapeString(o);
}
var me=arguments.callee;
var _1c5;
if(typeof (o.__json__)=="function"){
_1c5=o.__json__();
if(o!==_1c5){
return me(_1c5);
}
}
if(typeof (o.json)=="function"){
_1c5=o.json();
if(o!==_1c5){
return me(_1c5);
}
}
if(_1c3!="function"&&typeof (o.length)=="number"){
var res=[];
for(var i=0;i<o.length;i++){
var val=me(o[i]);
if(typeof (val)!="string"){
val="undefined";
}
res.push(val);
}
return "["+res.join(",")+"]";
}
try{
window.o=o;
_1c5=dojo.json.jsonRegistry.match(o);
return me(_1c5);
}
catch(e){
}
if(_1c3=="function"){
return null;
}
res=[];
for(var k in o){
var _1ca;
if(typeof (k)=="number"){
_1ca="\""+k+"\"";
}else{
if(typeof (k)=="string"){
_1ca=dojo.string.escapeString(k);
}else{
continue;
}
}
val=me(o[k]);
if(typeof (val)!="string"){
continue;
}
res.push(_1ca+":"+val);
}
return "{"+res.join(",")+"}";
}};
dojo.provide("dojo.collections.Store");
dojo.collections.Store=function(_1cb){
var data=[];
var _1cd={};
this.keyField="Id";
this.get=function(){
return data;
};
this.getByKey=function(key){
return _1cd[key];
};
this.getByIndex=function(idx){
return data[idx];
};
this.getIndexOf=function(key){
for(var i=0;i<data.length;i++){
if(data[i].key==key){
return i;
}
}
return -1;
};
this.getData=function(){
var arr=[];
for(var i=0;i<data.length;i++){
arr.push(data[i].src);
}
return arr;
};
this.getDataByKey=function(key){
if(_1cd[key]!=null){
return _1cd[key].src;
}
return null;
};
this.getIndexOfData=function(obj){
for(var i=0;i<data.length;i++){
if(data[i].src==obj){
return i;
}
}
return -1;
};
this.getDataByIndex=function(idx){
if(data[idx]){
return data[idx].src;
}
return null;
};
this.update=function(obj,_1d9,val,_1db){
var _1dc=_1d9.split("."),i=0,o=obj,_1df;
if(_1dc.length>1){
_1df=_1dc.pop();
do{
if(_1dc[i].indexOf("()")>-1){
var temp=_1dc[i++].split("()")[0];
if(!o[temp]){
dojo.raise("dojo.collections.Store.getField(obj, '"+_1df+"'): '"+temp+"' is not a property of the passed object.");
}else{
o=o[temp]();
}
}else{
o=o[_1dc[i++]];
}
}while(i<_1dc.length&&o!=null);
}else{
_1df=_1dc[0];
}
obj[_1df]=val;
if(!_1db){
this.onUpdateField(obj,_1d9,val);
}
};
this.forEach=function(fn){
if(Array.forEach){
Array.forEach(data,fn,this);
}else{
for(var i=0;i<data.length;i++){
fn.call(this,data[i]);
}
}
};
this.forEachData=function(fn){
if(Array.forEach){
Array.forEach(this.getData(),fn,this);
}else{
var a=this.getData();
for(var i=0;i<a.length;i++){
fn.call(this,a[i]);
}
}
};
this.setData=function(arr,_1e7){
data=[];
for(var i=0;i<arr.length;i++){
var o={key:arr[i][this.keyField],src:arr[i]};
data.push(o);
_1cd[o.key]=o;
}
if(!_1e7){
this.onSetData();
}
};
this.clearData=function(_1ea){
data=[];
_1cd={};
if(!_1ea){
this.onClearData();
}
};
this.addData=function(obj,key,_1ed){
var k=key||obj[this.keyField];
if(_1cd[k]!=null){
var o=_1cd[k];
o.src=obj;
}else{
var o={key:k,src:obj};
data.push(o);
_1cd[o.key]=o;
}
if(!_1ed){
this.onAddData(o);
}
};
this.addDataRange=function(arr,_1f1){
var _1f2=[];
for(var i=0;i<arr.length;i++){
var k=arr[i][this.keyField];
if(_1cd[k]!=null){
var o=_1cd[k];
o.src=arr[i];
}else{
var o={key:k,src:arr[i]};
data.push(o);
_1cd[k]=o;
}
_1f2.push(o);
}
if(!_1f1){
this.onAddDataRange(_1f2);
}
};
this.addDataByIndex=function(obj,idx,key,_1f9){
var k=key||obj[this.keyField];
if(_1cd[k]!=null){
var i=this.getIndexOf(k);
var o=data.splice(i,1);
o.src=obj;
}else{
var o={key:k,src:obj};
_1cd[k]=o;
}
data.splice(idx,0,o);
if(!_1f9){
this.onAddData(o);
}
};
this.addDataRangeByIndex=function(arr,idx,_1ff){
var _200=[];
for(var i=0;i<arr.length;i++){
var k=arr[i][this.keyField];
if(_1cd[k]!=null){
var j=this.getIndexOf(k);
var o=data.splice(j,1);
o.src=arr[i];
}else{
var o={key:k,src:arr[i]};
_1cd[k]=o;
}
_200.push(o);
}
data.splice(idx,0,_200);
if(!_1ff){
this.onAddDataRange(_200);
}
};
this.removeData=function(obj,_206){
var idx=-1;
var o=null;
for(var i=0;i<data.length;i++){
if(data[i].src==obj){
idx=i;
o=data[i];
break;
}
}
if(!_206){
this.onRemoveData(o);
}
if(idx>-1){
data.splice(idx,1);
delete _1cd[o.key];
}
};
this.removeDataRange=function(idx,_20b,_20c){
var ret=data.splice(idx,_20b);
for(var i=0;i<ret.length;i++){
delete _1cd[ret[i].key];
}
if(!_20c){
this.onRemoveDataRange(ret);
}
return ret;
};
this.removeDataByKey=function(key,_210){
this.removeData(this.getDataByKey(key),_210);
};
this.removeDataByIndex=function(idx,_212){
this.removeData(this.getDataByIndex(idx),_212);
};
if(_1cb&&_1cb.length&&_1cb[0]){
this.setData(_1cb,true);
}
};
dojo.extend(dojo.collections.Store,{getField:function(obj,_214){
var _215=_214.split("."),i=0,o=obj;
do{
if(_215[i].indexOf("()")>-1){
var temp=_215[i++].split("()")[0];
if(!o[temp]){
dojo.raise("dojo.collections.Store.getField(obj, '"+_214+"'): '"+temp+"' is not a property of the passed object.");
}else{
o=o[temp]();
}
}else{
o=o[_215[i++]];
}
}while(i<_215.length&&o!=null);
if(i<_215.length){
dojo.raise("dojo.collections.Store.getField(obj, '"+_214+"'): '"+_214+"' is not a property of the passed object.");
}
return o;
},getFromHtml:function(meta,body,_21b){
var rows=body.rows;
var ctor=function(row){
var obj={};
for(var i=0;i<meta.length;i++){
var o=obj;
var data=row.cells[i].innerHTML;
var p=meta[i].getField();
if(p.indexOf(".")>-1){
p=p.split(".");
while(p.length>1){
var pr=p.shift();
o[pr]={};
o=o[pr];
}
p=p[0];
}
var type=meta[i].getType();
if(type==String){
o[p]=data;
}else{
if(data){
o[p]=new type(data);
}else{
o[p]=new type();
}
}
}
return obj;
};
var arr=[];
for(var i=0;i<rows.length;i++){
var o=ctor(rows[i]);
if(_21b){
_21b(o,rows[i]);
}
arr.push(o);
}
return arr;
},onSetData:function(){
},onClearData:function(){
},onAddData:function(obj){
},onAddDataRange:function(arr){
},onRemoveData:function(obj){
},onRemoveDataRange:function(arr){
},onUpdateField:function(obj,_22e,val){
}});
dojo.provide("dojo.gfx.color");
dojo.gfx.color.Color=function(r,g,b,a){
if(dojo.lang.isArray(r)){
this.r=r[0];
this.g=r[1];
this.b=r[2];
this.a=r[3]||1;
}else{
if(dojo.lang.isString(r)){
var rgb=dojo.gfx.color.extractRGB(r);
this.r=rgb[0];
this.g=rgb[1];
this.b=rgb[2];
this.a=g||1;
}else{
if(r instanceof dojo.gfx.color.Color){
this.r=r.r;
this.b=r.b;
this.g=r.g;
this.a=r.a;
}else{
this.r=r;
this.g=g;
this.b=b;
this.a=a;
}
}
}
};
dojo.gfx.color.Color.fromArray=function(arr){
return new dojo.gfx.color.Color(arr[0],arr[1],arr[2],arr[3]);
};
dojo.extend(dojo.gfx.color.Color,{toRgb:function(_236){
if(_236){
return this.toRgba();
}else{
return [this.r,this.g,this.b];
}
},toRgba:function(){
return [this.r,this.g,this.b,this.a];
},toHex:function(){
return dojo.gfx.color.rgb2hex(this.toRgb());
},toCss:function(){
return "rgb("+this.toRgb().join()+")";
},toString:function(){
return this.toHex();
},blend:function(_237,_238){
var rgb=null;
if(dojo.lang.isArray(_237)){
rgb=_237;
}else{
if(_237 instanceof dojo.gfx.color.Color){
rgb=_237.toRgb();
}else{
rgb=new dojo.gfx.color.Color(_237).toRgb();
}
}
return dojo.gfx.color.blend(this.toRgb(),rgb,_238);
}});
dojo.gfx.color.named={white:[255,255,255],black:[0,0,0],red:[255,0,0],green:[0,255,0],lime:[0,255,0],blue:[0,0,255],navy:[0,0,128],gray:[128,128,128],silver:[192,192,192]};
dojo.gfx.color.blend=function(a,b,_23c){
if(typeof a=="string"){
return dojo.gfx.color.blendHex(a,b,_23c);
}
if(!_23c){
_23c=0;
}
_23c=Math.min(Math.max(-1,_23c),1);
_23c=((_23c+1)/2);
var c=[];
for(var x=0;x<3;x++){
c[x]=parseInt(b[x]+((a[x]-b[x])*_23c));
}
return c;
};
dojo.gfx.color.blendHex=function(a,b,_241){
return dojo.gfx.color.rgb2hex(dojo.gfx.color.blend(dojo.gfx.color.hex2rgb(a),dojo.gfx.color.hex2rgb(b),_241));
};
dojo.gfx.color.extractRGB=function(_242){
var hex="0123456789abcdef";
_242=_242.toLowerCase();
if(_242.indexOf("rgb")==0){
var _244=_242.match(/rgba*\((\d+), *(\d+), *(\d+)/i);
var ret=_244.splice(1,3);
return ret;
}else{
var _246=dojo.gfx.color.hex2rgb(_242);
if(_246){
return _246;
}else{
return dojo.gfx.color.named[_242]||[255,255,255];
}
}
};
dojo.gfx.color.hex2rgb=function(hex){
var _248="0123456789ABCDEF";
var rgb=new Array(3);
if(hex.indexOf("#")==0){
hex=hex.substring(1);
}
hex=hex.toUpperCase();
if(hex.replace(new RegExp("["+_248+"]","g"),"")!=""){
return null;
}
if(hex.length==3){
rgb[0]=hex.charAt(0)+hex.charAt(0);
rgb[1]=hex.charAt(1)+hex.charAt(1);
rgb[2]=hex.charAt(2)+hex.charAt(2);
}else{
rgb[0]=hex.substring(0,2);
rgb[1]=hex.substring(2,4);
rgb[2]=hex.substring(4);
}
for(var i=0;i<rgb.length;i++){
rgb[i]=_248.indexOf(rgb[i].charAt(0))*16+_248.indexOf(rgb[i].charAt(1));
}
return rgb;
};
dojo.gfx.color.rgb2hex=function(r,g,b){
if(dojo.lang.isArray(r)){
g=r[1]||0;
b=r[2]||0;
r=r[0]||0;
}
var ret=dojo.lang.map([r,g,b],function(x){
x=new Number(x);
var s=x.toString(16);
while(s.length<2){
s="0"+s;
}
return s;
});
ret.unshift("#");
return ret.join("");
};
dojo.provide("dojo.gfx.color.hsl");
dojo.lang.extend(dojo.gfx.color.Color,{toHsl:function(){
return dojo.gfx.color.rgb2hsl(this.toRgb());
}});
dojo.gfx.color.rgb2hsl=function(r,g,b){
if(dojo.lang.isArray(r)){
b=r[2]||0;
g=r[1]||0;
r=r[0]||0;
}
r/=255;
g/=255;
b/=255;
var h=null;
var s=null;
var l=null;
var min=Math.min(r,g,b);
var max=Math.max(r,g,b);
var _259=max-min;
l=(min+max)/2;
s=0;
if((l>0)&&(l<1)){
s=_259/((l<0.5)?(2*l):(2-2*l));
}
h=0;
if(_259>0){
if((max==r)&&(max!=g)){
h+=(g-b)/_259;
}
if((max==g)&&(max!=b)){
h+=(2+(b-r)/_259);
}
if((max==b)&&(max!=r)){
h+=(4+(r-g)/_259);
}
h*=60;
}
h=(h==0)?360:Math.ceil((h/360)*255);
s=Math.ceil(s*255);
l=Math.ceil(l*255);
return [h,s,l];
};
dojo.gfx.color.hsl2rgb=function(h,s,l){
if(dojo.lang.isArray(h)){
l=h[2]||0;
s=h[1]||0;
h=h[0]||0;
}
h=(h/255)*360;
if(h==360){
h=0;
}
s=s/255;
l=l/255;
while(h<0){
h+=360;
}
while(h>360){
h-=360;
}
var r,g,b;
if(h<120){
r=(120-h)/60;
g=h/60;
b=0;
}else{
if(h<240){
r=0;
g=(240-h)/60;
b=(h-120)/60;
}else{
r=(h-240)/60;
g=0;
b=(360-h)/60;
}
}
r=Math.min(r,1);
g=Math.min(g,1);
b=Math.min(b,1);
r=2*s*r+(1-s);
g=2*s*g+(1-s);
b=2*s*b+(1-s);
if(l<0.5){
r=l*r;
g=l*g;
b=l*b;
}else{
r=(1-l)*r+2*l-1;
g=(1-l)*g+2*l-1;
b=(1-l)*b+2*l-1;
}
r=Math.ceil(r*255);
g=Math.ceil(g*255);
b=Math.ceil(b*255);
return [r,g,b];
};
dojo.gfx.color.hsl2hex=function(h,s,l){
var rgb=dojo.gfx.color.hsl2rgb(h,s,l);
return dojo.gfx.color.rgb2hex(rgb[0],rgb[1],rgb[2]);
};
dojo.gfx.color.hex2hsl=function(hex){
var rgb=dojo.gfx.color.hex2rgb(hex);
return dojo.gfx.color.rgb2hsl(rgb[0],rgb[1],rgb[2]);
};
dojo.provide("dojo.charting.*");
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(e){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _267=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_267.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_269,_26a){
var node=_269.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_26a&&node&&node.tagName&&node.tagName.toLowerCase()!=_26a.toLowerCase()){
node=dojo.dom.nextElement(node,_26a);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_26c,_26d){
var node=_26c.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_26d&&node&&node.tagName&&node.tagName.toLowerCase()!=_26d.toLowerCase()){
node=dojo.dom.prevElement(node,_26d);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_270){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_270&&_270.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_270);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_272){
if(!node){
return null;
}
if(_272){
_272=_272.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_272&&_272.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_272);
}
return node;
};
dojo.dom.moveChildren=function(_273,_274,trim){
var _276=0;
if(trim){
while(_273.hasChildNodes()&&_273.firstChild.nodeType==dojo.dom.TEXT_NODE){
_273.removeChild(_273.firstChild);
}
while(_273.hasChildNodes()&&_273.lastChild.nodeType==dojo.dom.TEXT_NODE){
_273.removeChild(_273.lastChild);
}
}
while(_273.hasChildNodes()){
_274.appendChild(_273.firstChild);
_276++;
}
return _276;
};
dojo.dom.copyChildren=function(_277,_278,trim){
var _27a=_277.cloneNode(true);
return this.moveChildren(_27a,_278,trim);
};
dojo.dom.replaceChildren=function(node,_27c){
var _27d=[];
if(dojo.render.html.ie){
for(var i=0;i<node.childNodes.length;i++){
_27d.push(node.childNodes[i]);
}
}
dojo.dom.removeChildren(node);
node.appendChild(_27c);
for(var i=0;i<_27d.length;i++){
dojo.dom.destroyNode(_27d[i]);
}
};
dojo.dom.removeChildren=function(node){
var _280=node.childNodes.length;
while(node.hasChildNodes()){
dojo.dom.removeNode(node.firstChild);
}
return _280;
};
dojo.dom.replaceNode=function(node,_282){
return node.parentNode.replaceChild(_282,node);
};
dojo.dom.destroyNode=function(node){
if(node.parentNode){
node=dojo.dom.removeNode(node);
}
if(node.nodeType!=3){
if(dojo.evalObjPath("dojo.event.browser.clean",false)){
dojo.event.browser.clean(node);
}
if(dojo.render.html.ie){
node.outerHTML="";
}
}
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_286,_287){
var _288=[];
var _289=(_286&&(_286 instanceof Function||typeof _286=="function"));
while(node){
if(!_289||_286(node)){
_288.push(node);
}
if(_287&&_288.length>0){
return _288[0];
}
node=node.parentNode;
}
if(_287){
return null;
}
return _288;
};
dojo.dom.getAncestorsByTag=function(node,tag,_28c){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_28c);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_291,_292){
if(_292&&node){
node=node.parentNode;
}
while(node){
if(node==_291){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _295=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _296=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_296.length;i++){
try{
doc=new ActiveXObject(_296[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_295.implementation)&&(_295.implementation.createDocument)){
doc=_295.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_299){
if(!_299){
_299="text/xml";
}
if(!dj_undef("DOMParser")){
var _29a=new DOMParser();
return _29a.parseFromString(str,_299);
}else{
if(!dj_undef("ActiveXObject")){
var _29b=dojo.dom.createDocument();
if(_29b){
_29b.async=false;
_29b.loadXML(str);
return _29b;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _29c=dojo.doc();
if(_29c.createElement){
var tmp=_29c.createElement("xml");
tmp.innerHTML=str;
if(_29c.implementation&&_29c.implementation.createDocument){
var _29e=_29c.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_29e.importNode(tmp.childNodes.item(i),true);
}
return _29e;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_2a1){
if(_2a1.firstChild){
_2a1.insertBefore(node,_2a1.firstChild);
}else{
_2a1.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_2a4){
if((_2a4!=true)&&(node===ref||node.nextSibling===ref)){
return false;
}
var _2a5=ref.parentNode;
_2a5.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_2a8){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_2a8!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_2a8);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_2ac){
if((!node)||(!ref)||(!_2ac)){
return false;
}
switch(_2ac.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_2ae,_2af){
var _2b0=_2ae.childNodes;
if(!_2b0.length||_2b0.length==_2af){
_2ae.appendChild(node);
return true;
}
if(_2af==0){
return dojo.dom.prependChild(node,_2ae);
}
return dojo.dom.insertAfter(node,_2b0[_2af-1]);
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _2b3=dojo.doc();
dojo.dom.replaceChildren(node,_2b3.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _2b4="";
if(node==null){
return _2b4;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_2b4+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_2b4+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _2b4;
}
};
dojo.dom.hasParent=function(node){
return Boolean(node&&node.parentNode&&dojo.dom.isNode(node.parentNode));
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_2ba,_2bb,_2bc){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_2ba,_2bb,_2bc);
}else{
var _2bd=elem.ownerDocument;
var _2be=_2bd.createNode(2,_2bb,_2ba);
_2be.nodeValue=_2bc;
elem.setAttributeNode(_2be);
}
};
dojo.provide("dojo.svg");
dojo.mixin(dojo.svg,dojo.dom);
dojo.svg.graphics=dojo.svg.g=new function(d){
this.suspend=function(){
try{
d.documentElement.suspendRedraw(0);
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unsuspendRedraw(0);
}
catch(e){
}
};
this.force=function(){
try{
d.documentElement.forceRedraw();
}
catch(e){
}
};
}(document);
dojo.svg.animations=dojo.svg.anim=new function(d){
this.arePaused=function(){
try{
return d.documentElement.animationsPaused();
}
catch(e){
return false;
}
};
this.pause=function(){
try{
d.documentElement.pauseAnimations();
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unpauseAnimations();
}
catch(e){
}
};
}(document);
dojo.svg.toCamelCase=function(_2c1){
var arr=_2c1.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.svg.toSelectorCase=function(_2c5){
return _2c5.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.svg.getStyle=function(node,_2c7){
return document.defaultView.getComputedStyle(node,_2c7);
};
dojo.svg.getNumericStyle=function(node,_2c9){
return parseFloat(dojo.svg.getStyle(node,_2c9));
};
dojo.svg.getOpacity=function(node){
return Math.min(1,dojo.svg.getNumericStyle(node,"fill-opacity"));
};
dojo.svg.setOpacity=function(node,_2cc){
node.setAttributeNS(this.xmlns.svg,"fill-opacity",_2cc);
node.setAttributeNS(this.xmlns.svg,"stroke-opacity",_2cc);
};
dojo.svg.clearOpacity=function(node){
node.setAttributeNS(this.xmlns.svg,"fill-opacity","1.0");
node.setAttributeNS(this.xmlns.svg,"stroke-opacity","1.0");
};
dojo.svg.getCoords=function(node){
if(node.getBBox){
var box=node.getBBox();
return {x:box.x,y:box.y};
}
return null;
};
dojo.svg.setCoords=function(node,_2d1){
var p=dojo.svg.getCoords();
if(!p){
return;
}
var dx=p.x-_2d1.x;
var dy=p.y-_2d1.y;
dojo.svg.translate(node,dx,dy);
};
dojo.svg.getDimensions=function(node){
if(node.getBBox){
var box=node.getBBox();
return {width:box.width,height:box.height};
}
return null;
};
dojo.svg.setDimensions=function(node,dim){
if(node.width){
node.width.baseVal.value=dim.width;
node.height.baseVal.value=dim.height;
}else{
if(node.r){
node.r.baseVal.value=Math.min(dim.width,dim.height)/2;
}else{
if(node.rx){
node.rx.baseVal.value=dim.width/2;
node.ry.baseVal.value=dim.height/2;
}
}
}
};
dojo.svg.translate=function(node,dx,dy){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setTranslate(dx,dy);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.scale=function(node,_2de,_2df){
if(!_2df){
var _2df=_2de;
}
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setScale(_2de,_2df);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.rotate=function(node,ang,cx,cy){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
if(cx==null){
t.setMatrix(t.matrix.rotate(ang));
}else{
t.setRotate(ang,cx,cy);
}
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.skew=function(node,ang,axis){
var dir=axis||"x";
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
if(dir!="x"){
t.setSkewY(ang);
}else{
t.setSkewX(ang);
}
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.flip=function(node,axis){
var dir=axis||"x";
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix((dir!="x")?t.matrix.flipY():t.matrix.flipX());
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.invert=function(node){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix(t.matrix.inverse());
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.applyMatrix=function(node,a,b,c,d,e,f){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var m;
if(b){
var m=node.ownerSVGElement.createSVGMatrix();
m.a=a;
m.b=b;
m.c=c;
m.d=d;
m.e=e;
m.f=f;
}else{
m=a;
}
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix(m);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.group=function(_2fa){
var p=_2fa.item(0).parentNode;
var g=document.createElementNS(this.xmlns.svg,"g");
for(var i=0;i<_2fa.length;i++){
g.appendChild(_2fa.item(i));
}
p.appendChild(g);
return g;
};
dojo.svg.ungroup=function(g){
var p=g.parentNode;
while(g.childNodes.length>0){
p.appendChild(g.childNodes.item(0));
}
p.removeChild(g);
};
dojo.svg.getGroup=function(node){
var a=this.getAncestors(node);
for(var i=0;i<a.length;i++){
if(a[i].nodeType==this.ELEMENT_NODE&&a[i].nodeName.toLowerCase()=="g"){
return a[i];
}
}
return null;
};
dojo.svg.bringToFront=function(node){
var n=this.getGroup(node)||node;
n.ownerSVGElement.appendChild(n);
};
dojo.svg.sendToBack=function(node){
var n=this.getGroup(node)||node;
n.ownerSVGElement.insertBefore(n,n.ownerSVGElement.firstChild);
};
dojo.svg.bringForward=function(node){
var n=this.getGroup(node)||node;
if(this.getLastChildElement(n.parentNode)!=n){
this.insertAfter(n,this.getNextSiblingElement(n),true);
}
};
dojo.svg.sendBackward=function(node){
var n=this.getGroup(node)||node;
if(this.getFirstChildElement(n.parentNode)!=n){
this.insertBefore(n,this.getPreviousSiblingElement(n),true);
}
};
dojo.svg.createNodesFromText=function(txt,wrap){
var _30d=(new DOMParser()).parseFromString(txt,"text/xml").normalize();
if(wrap){
return [_30d.firstChild.cloneNode(true)];
}
var _30e=[];
for(var x=0;x<_30d.childNodes.length;x++){
_30e.push(_30d.childNodes.item(x).cloneNode(true));
}
return _30e;
};
dojo.provide("dojo.charting.Axis");
dojo.charting.Axis=function(_310,_311,_312){
var id="dojo-charting-axis-"+dojo.charting.Axis.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.scale=_311||"linear";
this.label=_310||"";
this.showLabel=true;
this.showLabels=true;
this.showLines=false;
this.showTicks=false;
this.range={upper:100,lower:0};
this.origin="min";
this._origin=null;
this.labels=_312||[];
this._labels=[];
this.nodes={main:null,axis:null,label:null,labels:null,lines:null,ticks:null};
this._rerender=false;
};
dojo.charting.Axis.count=0;
dojo.extend(dojo.charting.Axis,{getCoord:function(val,_316,plot){
val=parseFloat(val,10);
var area=_316.getArea();
if(plot.axisX==this){
var _319=0-this.range.lower;
var min=this.range.lower+_319;
var max=this.range.upper+_319;
val+=_319;
return (val*((area.right-area.left)/max))+area.left;
}else{
var max=this.range.upper;
var min=this.range.lower;
var _319=0;
if(min<0){
_319+=Math.abs(min);
}
max+=_319;
min+=_319;
val+=_319;
var pmin=area.bottom;
var pmax=area.top;
return (((pmin-pmax)/(max-min))*(max-val))+pmax;
}
},initializeOrigin:function(_31e,_31f){
if(this._origin==null){
this._origin=this.origin;
}
if(isNaN(this._origin)){
if(this._origin.toLowerCase()=="max"){
this.origin=_31e.range[(_31f=="y")?"upper":"lower"];
}else{
if(this._origin.toLowerCase()=="min"){
this.origin=_31e.range[(_31f=="y")?"lower":"upper"];
}else{
this.origin=0;
}
}
}
},initializeLabels:function(){
this._labels=[];
if(this.labels.length==0){
this.showLabels=false;
this.showLines=false;
this.showTicks=false;
}else{
if(this.labels[0].label&&this.labels[0].value!=null){
for(var i=0;i<this.labels.length;i++){
this._labels.push(this.labels[i]);
}
}else{
if(!isNaN(this.labels[0])){
for(var i=0;i<this.labels.length;i++){
this._labels.push({label:this.labels[i],value:this.labels[i]});
}
}else{
var a=[];
for(var i=0;i<this.labels.length;i++){
a.push(this.labels[i]);
}
var s=a.shift();
this._labels.push({label:s,value:this.range.lower});
if(a.length>0){
var s=a.pop();
this._labels.push({label:s,value:this.range.upper});
}
if(a.length>0){
var _323=this.range.upper-this.range.lower;
var step=_323/(this.labels.length-1);
for(var i=1;i<=a.length;i++){
this._labels.push({label:a[i-1],value:this.range.lower+(step*i)});
}
}
}
}
}
},initialize:function(_325,plot,_327,_328){
this.destroy();
this.initializeOrigin(_327,_328);
this.initializeLabels();
var node=this.render(_325,plot,_327,_328);
return node;
},destroy:function(){
for(var p in this.nodes){
while(this.nodes[p]&&this.nodes[p].childNodes.length>0){
this.nodes[p].removeChild(this.nodes[p].childNodes[0]);
}
if(this.nodes[p]&&this.nodes[p].parentNode){
this.nodes[p].parentNode.removeChild(this.nodes[p]);
}
this.nodes[p]=null;
}
}});
dojo.provide("dojo.charting.svg.Axis");
if(dojo.render.svg.capable){
dojo.extend(dojo.charting.Axis,{renderLines:function(_32b,plot,_32d){
if(this.nodes.lines){
while(this.nodes.lines.childNodes.length>0){
this.nodes.lines.removeChild(this.nodes.lines.childNodes[0]);
}
if(this.nodes.lines.parentNode){
this.nodes.lines.parentNode.removeChild(this.nodes.lines);
this.nodes.lines=null;
}
}
var area=_32b.getArea();
var g=this.nodes.lines=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-lines");
for(var i=0;i<this._labels.length;i++){
if(this._labels[i].value==this.origin){
continue;
}
var v=this.getCoord(this._labels[i].value,_32b,plot);
var l=document.createElementNS(dojo.svg.xmlns.svg,"line");
l.setAttribute("style","stroke:#999;stroke-width:1px;stroke-dasharray:1,4;");
if(_32d=="x"){
l.setAttribute("y1",area.top);
l.setAttribute("y2",area.bottom);
l.setAttribute("x1",v);
l.setAttribute("x2",v);
}else{
if(_32d=="y"){
l.setAttribute("y1",v);
l.setAttribute("y2",v);
l.setAttribute("x1",area.left);
l.setAttribute("x2",area.right);
}
}
g.appendChild(l);
}
return g;
},renderTicks:function(_333,plot,_335,_336){
if(this.nodes.ticks){
while(this.nodes.ticks.childNodes.length>0){
this.nodes.ticks.removeChild(this.nodes.ticks.childNodes[0]);
}
if(this.nodes.ticks.parentNode){
this.nodes.ticks.parentNode.removeChild(this.nodes.ticks);
this.nodes.ticks=null;
}
}
var g=this.nodes.ticks=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-ticks");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_333,plot);
var l=document.createElementNS(dojo.svg.xmlns.svg,"line");
l.setAttribute("style","stroke:#000;stroke-width:1pt;");
if(_335=="x"){
l.setAttribute("y1",_336);
l.setAttribute("y2",_336+3);
l.setAttribute("x1",v);
l.setAttribute("x2",v);
}else{
if(_335=="y"){
l.setAttribute("y1",v);
l.setAttribute("y2",v);
l.setAttribute("x1",_336-2);
l.setAttribute("x2",_336+2);
}
}
g.appendChild(l);
}
return g;
},renderLabels:function(_33b,plot,_33d,_33e,_33f,_340){
function createLabel(_341,x,y,_344,_345){
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",(_33d=="x"?y:y+2));
text.setAttribute("style","text-anchor:"+_345+";font-family:sans-serif;font-size:"+_344+"px;fill:#000;");
text.appendChild(document.createTextNode(_341));
return text;
}
if(this.nodes.labels){
while(this.nodes.labels.childNodes.length>0){
this.nodes.labels.removeChild(this.nodes.labels.childNodes[0]);
}
if(this.nodes.labels.parentNode){
this.nodes.labels.parentNode.removeChild(this.nodes.labels);
this.nodes.labels=null;
}
}
var g=this.nodes.labels=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-labels");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_33b,plot);
if(_33d=="x"){
g.appendChild(createLabel(this._labels[i].label,v,_33e,_33f,_340));
}else{
if(_33d=="y"){
g.appendChild(createLabel(this._labels[i].label,_33e,v,_33f,_340));
}
}
}
return g;
},render:function(_34a,plot,_34c,_34d){
if(!this._rerender&&this.nodes.main){
return this.nodes.main;
}
this._rerender=false;
var area=_34a.getArea();
var _34f=1;
var _350="stroke:#000;stroke-width:"+_34f+"px;";
var _351=10;
var _352=_34c.getCoord(this.origin,_34a,plot);
this.nodes.main=document.createElementNS(dojo.svg.xmlns.svg,"g");
var g=this.nodes.main;
g.setAttribute("id",this.getId());
var line=this.nodes.axis=document.createElementNS(dojo.svg.xmlns.svg,"line");
if(_34d=="x"){
line.setAttribute("y1",_352);
line.setAttribute("y2",_352);
line.setAttribute("x1",area.left-_34f);
line.setAttribute("x2",area.right+_34f);
line.setAttribute("style",_350);
var y=_352+_351+2;
if(this.showLines){
g.appendChild(this.renderLines(_34a,plot,_34d,y));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_34a,plot,_34d,_352));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_34a,plot,_34d,y,_351,"middle"));
}
if(this.showLabel&&this.label){
var x=_34a.size.width/2;
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",(_352+(_351*2)+(_351/2)));
text.setAttribute("style","text-anchor:middle;font-family:sans-serif;font-weight:bold;font-size:"+(_351+2)+"px;fill:#000;");
text.appendChild(document.createTextNode(this.label));
g.appendChild(text);
}
}else{
line.setAttribute("x1",_352);
line.setAttribute("x2",_352);
line.setAttribute("y1",area.top);
line.setAttribute("y2",area.bottom);
line.setAttribute("style",_350);
var _358=this.origin==_34c.range.upper;
var x=_352+(_358?4:-4);
var _359=_358?"start":"end";
if(this.showLines){
g.appendChild(this.renderLines(_34a,plot,_34d,x));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_34a,plot,_34d,_352));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_34a,plot,_34d,x,_351,_359));
}
if(this.showLabel&&this.label){
var x=_358?(_352+(_351*2)+(_351/2)):(_352-(_351*4));
var y=_34a.size.height/2;
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",y);
text.setAttribute("transform","rotate(90, "+x+", "+y+")");
text.setAttribute("style","text-anchor:middle;font-family:sans-serif;font-weight:bold;font-size:"+(_351+2)+"px;fill:#000;");
text.appendChild(document.createTextNode(this.label));
g.appendChild(text);
}
}
g.appendChild(line);
return g;
}});
}
dojo.provide("dojo.charting.vml.Axis");
if(dojo.render.vml.capable){
dojo.extend(dojo.charting.Axis,{renderLines:function(_35a,plot,_35c){
if(this.nodes.lines){
while(this.nodes.lines.childNodes.length>0){
this.nodes.lines.removeChild(this.nodes.lines.childNodes[0]);
}
if(this.nodes.lines.parentNode){
this.nodes.lines.parentNode.removeChild(this.nodes.lines);
this.nodes.lines=null;
}
}
var area=_35a.getArea();
var g=this.nodes.lines=document.createElement("div");
g.setAttribute("id",this.getId()+"-lines");
for(var i=0;i<this._labels.length;i++){
if(this._labels[i].value==this.origin){
continue;
}
var v=this.getCoord(this._labels[i].value,_35a,plot);
var l=document.createElement("v:line");
var str=document.createElement("v:stroke");
str.dashstyle="dot";
l.appendChild(str);
l.setAttribute("strokecolor","#666");
l.setAttribute("strokeweight","1px");
var s=l.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_35c=="x"){
l.setAttribute("from",v+"px,"+area.top+"px");
l.setAttribute("to",v+"px,"+area.bottom+"px");
}else{
if(_35c=="y"){
l.setAttribute("from",area.left+"px,"+v+"px");
l.setAttribute("to",area.right+"px,"+v+"px");
}
}
g.appendChild(l);
}
return g;
},renderTicks:function(_364,plot,_366,_367){
if(this.nodes.ticks){
while(this.nodes.ticks.childNodes.length>0){
this.nodes.ticks.removeChild(this.nodes.ticks.childNodes[0]);
}
if(this.nodes.ticks.parentNode){
this.nodes.ticks.parentNode.removeChild(this.nodes.ticks);
this.nodes.ticks=null;
}
}
var g=this.nodes.ticks=document.createElement("div");
g.setAttribute("id",this.getId()+"-ticks");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_364,plot);
var l=document.createElement("v:line");
l.setAttribute("strokecolor","#000");
l.setAttribute("strokeweight","1px");
var s=l.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_366=="x"){
l.setAttribute("from",v+"px,"+_367+"px");
l.setAttribute("to",v+"px,"+(_367+3)+"px");
}else{
if(_366=="y"){
l.setAttribute("from",(_367-2)+"px,"+v+"px");
l.setAttribute("to",(_367+2)+"px,"+v+"px");
}
}
g.appendChild(l);
}
return g;
},renderLabels:function(_36d,plot,_36f,_370,_371,_372){
function createLabel(_373,x,y,_376,_377){
var text=document.createElement("div");
var s=text.style;
text.innerHTML=_373;
s.fontSize=_376+"px";
s.fontFamily="sans-serif";
s.position="absolute";
s.top=y+"px";
if(_377=="center"){
s.left=x+"px";
s.textAlign="center";
}else{
if(_377=="left"){
s.left=x+"px";
s.textAlign="left";
}else{
if(_377=="right"){
s.right=x+"px";
s.textAlign="right";
}
}
}
return text;
}
if(this.nodes.labels){
while(this.nodes.labels.childNodes.length>0){
this.nodes.labels.removeChild(this.nodes.labels.childNodes[0]);
}
if(this.nodes.labels.parentNode){
this.nodes.labels.parentNode.removeChild(this.nodes.labels);
this.nodes.labels=null;
}
}
var g=this.nodes.labels=document.createElement("div");
g.setAttribute("id",this.getId()+"-labels");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_36d,plot);
if(_36f=="x"){
var node=createLabel(this._labels[i].label,v,_370,_371,_372);
document.body.appendChild(node);
node.style.left=v-(node.offsetWidth/2)+"px";
g.appendChild(node);
}else{
if(_36f=="y"){
var node=createLabel(this._labels[i].label,_370,v,_371,_372);
document.body.appendChild(node);
node.style.top=v-(node.offsetHeight/2)+"px";
g.appendChild(node);
}
}
}
return g;
},render:function(_37e,plot,_380,_381){
if(!this._rerender&&this.nodes.main){
return this.nodes.main;
}
this._rerender=false;
var area=_37e.getArea();
var _383=1;
var _384="stroke:#000;stroke-width:"+_383+"px;";
var _385=10;
var _386=_380.getCoord(this.origin,_37e,plot);
var g=this.nodes.main=document.createElement("div");
g.setAttribute("id",this.getId());
var line=this.nodes.axis=document.createElement("v:line");
line.setAttribute("strokecolor","#000");
line.setAttribute("strokeweight",_383+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_381=="x"){
line.setAttribute("from",area.left+"px,"+_386+"px");
line.setAttribute("to",area.right+"px,"+_386+"px");
var y=_386+Math.floor(_385/2);
if(this.showLines){
g.appendChild(this.renderLines(_37e,plot,_381,y));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_37e,plot,_381,_386));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_37e,plot,_381,y,_385,"center"));
}
if(this.showLabel&&this.label){
var x=_37e.size.width/2;
var y=_386+Math.round(_385*1.5);
var text=document.createElement("div");
var s=text.style;
text.innerHTML=this.label;
s.fontSize=(_385+2)+"px";
s.fontFamily="sans-serif";
s.fontWeight="bold";
s.position="absolute";
s.top=y+"px";
s.left=x+"px";
s.textAlign="center";
document.body.appendChild(text);
text.style.left=x-(text.offsetWidth/2)+"px";
g.appendChild(text);
}
}else{
line.setAttribute("from",_386+"px,"+area.top+"px");
line.setAttribute("to",_386+"px,"+area.bottom+"px");
var _38d=this.origin==_380.range.upper;
var x=_386+4;
var _38e="left";
if(!_38d){
x=area.right-_386+_385+4;
_38e="right";
if(_386==area.left){
x+=(_385*2)-(_385/2);
}
}
if(this.showLines){
g.appendChild(this.renderLines(_37e,plot,_381,x));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_37e,plot,_381,_386));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_37e,plot,_381,x,_385,_38e));
}
if(this.showLabel&&this.label){
x+=(_385*2)-2;
var y=_37e.size.height/2;
var text=document.createElement("div");
var s=text.style;
text.innerHTML=this.label;
s.fontSize=(_385+2)+"px";
s.fontFamily="sans-serif";
s.fontWeight="bold";
s.position="absolute";
s.height=_37e.size.height+"px";
s.writingMode="tb-rl";
s.textAlign="center";
s[_38e]=x+"px";
document.body.appendChild(text);
s.top=y-(text.offsetHeight/2)+"px";
g.appendChild(text);
}
}
g.appendChild(line);
return g;
}});
}
dojo.provide("dojo.charting.Plotters");
dojo.provide("dojo.charting.svg.Plotters");
if(dojo.render.svg.capable){
dojo.mixin(dojo.charting.Plotters,{Bar:function(_38f,plot,_391,_392){
var area=_38f.getArea();
var _394=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_391);
data.push(tmp);
}
var _399=8;
var _39a=data[0].length;
if(_39a==0){
return _394;
}
var _39b=((area.right-area.left)-(_399*(_39a-1)))/_39a;
var _39c=_39b/n;
var _39d=plot.axisY.getCoord(plot.axisX.origin,_38f,plot);
for(var i=0;i<_39a;i++){
var _39e=area.left+(_39b*i)+(_399*i);
for(var j=0;j<n;j++){
var _3a0=data[j][i].y;
var yA=_39d;
var x=_39e+(_39c*j);
var y=plot.axisY.getCoord(_3a0,_38f,plot);
var h=Math.abs(yA-y);
if(_3a0<plot.axisX.origin){
yA=y;
y=_39d;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",_39c);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_392){
_392(bar,data[j][i].src);
}
_394.appendChild(bar);
}
}
return _394;
},HorizontalBar:function(_3a6,plot,_3a8,_3a9){
var area=_3a6.getArea();
var _3ab=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3a8);
data.push(tmp);
}
var _3b0=6;
var _3b1=data[0].length;
if(_3b1==0){
return _3ab;
}
var h=((area.bottom-area.top)-(_3b0*(_3b1-1)))/_3b1;
var barH=h/n;
var _3b4=plot.axisX.getCoord(0,_3a6,plot);
for(var i=0;i<_3b1;i++){
var _3b5=area.top+(h*i)+(_3b0*i);
for(var j=0;j<n;j++){
var _3b7=data[j][i].y;
var y=_3b5+(barH*j);
var xA=_3b4;
var x=plot.axisX.getCoord(_3b7,_3a6,plot);
var w=Math.abs(x-xA);
if(_3b7>0){
x=_3b4;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",xA);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",barH);
bar.setAttribute("fill-opacity","0.6");
if(_3a9){
_3a9(bar,data[j][i].src);
}
_3ab.appendChild(bar);
}
}
return _3ab;
},Gantt:function(_3bd,plot,_3bf,_3c0){
var area=_3bd.getArea();
var _3c2=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3bf);
data.push(tmp);
}
var _3c7=2;
var _3c8=data[0].length;
if(_3c8==0){
return _3c2;
}
var h=((area.bottom-area.top)-(_3c7*(_3c8-1)))/_3c8;
var barH=h/n;
for(var i=0;i<_3c8;i++){
var _3cb=area.top+(h*i)+(_3c7*i);
for(var j=0;j<n;j++){
var high=data[j][i].high;
var low=data[j][i].low;
if(low>high){
var t=high;
high=low;
low=t;
}
var x=plot.axisX.getCoord(low,_3bd,plot);
var w=plot.axisX.getCoord(high,_3bd,plot)-x;
var y=_3cb+(barH*j);
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",barH);
bar.setAttribute("fill-opacity","0.6");
if(_3c0){
_3c0(bar,data[j][i].src);
}
_3c2.appendChild(bar);
}
}
return _3c2;
},StackedArea:function(_3d4,plot,_3d6,_3d7){
var area=_3d4.getArea();
var _3d9=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
var _3dc=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3d6);
for(var j=0;j<tmp.length;j++){
if(i==0){
_3dc.push(tmp[j].y);
}else{
_3dc[j]+=tmp[j].y;
}
tmp[j].y=_3dc[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
path.setAttribute("fill",data[i][0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[i][0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _3e3=data[i];
var x=plot.axisX.getCoord(_3e3[j].x,_3d4,plot);
var y=plot.axisY.getCoord(_3e3[j].y,_3d4,plot);
if(j==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",_3e3[j].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
_3d9.appendChild(c);
if(_3d7){
_3d7(c,data[i].src);
}
}
if(i==0){
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_3d4,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0][0].x,_3d4,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_3d4,plot));
cmd.push("Z");
}else{
var _3e3=data[i-1];
cmd.push("L");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_3e3[_3e3.length-1].y,_3d4,plot)));
for(var j=_3e3.length-2;j>=0;j--){
var x=plot.axisX.getCoord(_3e3[j].x,_3d4,plot);
var y=plot.axisY.getCoord(_3e3[j].y,_3d4,plot);
cmd.push("L");
cmd.push(x+","+y);
}
}
path.setAttribute("d",cmd.join(" ")+" Z");
_3d9.appendChild(path);
}
return _3d9;
},StackedCurvedArea:function(_3e7,plot,_3e9,_3ea){
var _3eb=3;
var area=_3e7.getArea();
var _3ed=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
var _3f0=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3e9);
for(var j=0;j<tmp.length;j++){
if(i==0){
_3f0.push(tmp[j].y);
}else{
_3f0[j]+=tmp[j].y;
}
tmp[j].y=_3f0[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
path.setAttribute("fill",data[i][0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[i][0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _3f7=data[i];
var x=plot.axisX.getCoord(_3f7[j].x,_3e7,plot);
var y=plot.axisY.getCoord(_3f7[j].y,_3e7,plot);
var dx=area.left+1;
var dy=area.bottom;
if(j>0){
dx=x-plot.axisX.getCoord(_3f7[j-1].x,_3e7,plot);
dy=plot.axisY.getCoord(_3f7[j-1].y,_3e7,plot);
}
if(j==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_3eb-1)*(dx/_3eb);
cmd.push(cx+","+dy);
cx=x-(dx/_3eb);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",_3f7[j].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
_3ed.appendChild(c);
if(_3ea){
_3ea(c,data[i].src);
}
}
if(i==0){
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_3e7,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0][0].x,_3e7,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_3e7,plot));
cmd.push("Z");
}else{
var _3f7=data[i-1];
cmd.push("L");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_3f7[_3f7.length-1].y,_3e7,plot)));
for(var j=_3f7.length-2;j>=0;j--){
var x=plot.axisX.getCoord(_3f7[j].x,_3e7,plot);
var y=plot.axisY.getCoord(_3f7[j].y,_3e7,plot);
var dx=x-plot.axisX.getCoord(_3f7[j+1].x,_3e7,plot);
var dy=plot.axisY.getCoord(_3f7[j+1].y,_3e7,plot);
cmd.push("C");
var cx=x-(_3eb-1)*(dx/_3eb);
cmd.push(cx+","+dy);
cx=x-(dx/_3eb);
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
}
path.setAttribute("d",cmd.join(" ")+" Z");
_3ed.appendChild(path);
}
return _3ed;
},DataBar:function(data,_3ff,plot,_401){
var area=_3ff.getArea();
var _403=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var w=(area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower);
var _406=plot.axisY.getCoord(plot.axisX.origin,_3ff,plot);
for(var i=0;i<n;i++){
var _408=data[i].y;
var yA=_406;
var x=plot.axisX.getCoord(data[i].x,_3ff,plot)-(w/2);
var y=plot.axisY.getCoord(_408,_3ff,plot);
var h=Math.abs(yA-y);
if(_408<plot.axisX.origin){
yA=y;
y=_406;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_401){
_401(bar,data[i].src);
}
_403.appendChild(bar);
}
return _403;
},Line:function(data,_40f,plot,_411){
var area=_40f.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill","none");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","2");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_40f,plot);
var y=plot.axisY.getCoord(data[i].y,_40f,plot);
if(i==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_411){
_411(c,data[i].src);
}
}
path.setAttribute("d",cmd.join(" "));
return line;
},CurvedLine:function(data,_41b,plot,_41d){
var _41e=3;
var area=_41b.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill","none");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","2");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_41b,plot);
var y=plot.axisY.getCoord(data[i].y,_41b,plot);
var dx=area.left+1;
var dy=area.bottom;
if(i>0){
dx=x-plot.axisX.getCoord(data[i-1].x,_41b,plot);
dy=plot.axisY.getCoord(data[i-1].y,_41b,plot);
}
if(i==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_41e-1)*(dx/_41e);
cmd.push(cx+","+dy);
cx=x-(dx/_41e);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_41d){
_41d(c,data[i].src);
}
}
path.setAttribute("d",cmd.join(" "));
return line;
},Area:function(data,_42b,plot,_42d){
var area=_42b.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill",data[0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_42b,plot);
var y=plot.axisY.getCoord(data[i].y,_42b,plot);
if(i==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_42d){
_42d(c,data[i].src);
}
}
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_42b,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0].x,_42b,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_42b,plot));
cmd.push("Z");
path.setAttribute("d",cmd.join(" "));
return line;
},CurvedArea:function(data,_437,plot,_439){
var _43a=3;
var area=_437.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill",data[0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_437,plot);
var y=plot.axisY.getCoord(data[i].y,_437,plot);
var dx=area.left+1;
var dy=area.bottom;
if(i>0){
dx=x-plot.axisX.getCoord(data[i-1].x,_437,plot);
dy=plot.axisY.getCoord(data[i-1].y,_437,plot);
}
if(i==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_43a-1)*(dx/_43a);
cmd.push(cx+","+dy);
cx=x-(dx/_43a);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_439){
_439(c,data[i].src);
}
}
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_437,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0].x,_437,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_437,plot));
cmd.push("Z");
path.setAttribute("d",cmd.join(" "));
return line;
},HighLow:function(data,_447,plot,_449){
var area=_447.getArea();
var _44b=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var x=plot.axisX.getCoord(data[i].x,_447,plot)-(w/2);
var y=plot.axisY.getCoord(high,_447,plot);
var h=plot.axisY.getCoord(low,_447,plot)-y;
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_449){
_449(bar,data[i].src);
}
_44b.appendChild(bar);
}
return _44b;
},HighLowClose:function(data,_458,plot,_45a){
var area=_458.getArea();
var _45c=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_458,plot)-(w/2);
var y=plot.axisY.getCoord(high,_458,plot);
var h=plot.axisY.getCoord(low,_458,plot)-y;
var _468=plot.axisY.getCoord(c,_458,plot);
var g=document.createElementNS(dojo.svg.xmlns.svg,"g");
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
g.appendChild(bar);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x);
line.setAttribute("x2",x+w+(part*2));
line.setAttribute("y1",_468);
line.setAttribute("y2",_468);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
if(_45a){
_45a(g,data[i].src);
}
_45c.appendChild(g);
}
return _45c;
},HighLowOpenClose:function(data,_46d,plot,_46f){
var area=_46d.getArea();
var _471=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var o=data[i].open;
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_46d,plot)-(w/2);
var y=plot.axisY.getCoord(high,_46d,plot);
var h=plot.axisY.getCoord(low,_46d,plot)-y;
var open=plot.axisY.getCoord(o,_46d,plot);
var _47f=plot.axisY.getCoord(c,_46d,plot);
var g=document.createElementNS(dojo.svg.xmlns.svg,"g");
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
g.appendChild(bar);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x-(part*2));
line.setAttribute("x2",x+w);
line.setAttribute("y1",open);
line.setAttribute("y2",open);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x);
line.setAttribute("x2",x+w+(part*2));
line.setAttribute("y1",_47f);
line.setAttribute("y2",_47f);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
if(_46f){
_46f(g,data[i].src);
}
_471.appendChild(g);
}
return _471;
},Scatter:function(data,_484,plot,_486){
var r=7;
var _488=document.createElementNS(dojo.svg.xmlns.svg,"g");
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_484,plot);
var y=plot.axisY.getCoord(data[i].y,_484,plot);
var _48c=document.createElementNS(dojo.svg.xmlns.svg,"path");
_48c.setAttribute("fill",data[i].series.color);
_48c.setAttribute("stroke-width","0");
_48c.setAttribute("d","M "+x+","+(y-r)+" "+"Q "+x+","+y+" "+(x+r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y+r)+" "+"Q "+x+","+y+" "+(x-r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y-r)+" "+"Z");
if(_486){
_486(_48c,data[i].src);
}
_488.appendChild(_48c);
}
return _488;
},Bubble:function(data,_48e,plot,_490){
var _491=document.createElementNS(dojo.svg.xmlns.svg,"g");
var _492=1;
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_48e,plot);
var y=plot.axisY.getCoord(data[i].y,_48e,plot);
if(i==0){
var raw=data[i].size;
var dy=plot.axisY.getCoord(data[i].y+raw,_48e,plot)-y;
_492=dy/raw;
}
if(_492<1){
_492=1;
}
var _498=document.createElementNS(dojo.svg.xmlns.svg,"circle");
_498.setAttribute("fill",data[i].series.color);
_498.setAttribute("fill-opacity","0.8");
_498.setAttribute("stroke",data[i].series.color);
_498.setAttribute("stroke-width","1");
_498.setAttribute("cx",x);
_498.setAttribute("cy",y);
_498.setAttribute("r",(data[i].size/2)*_492);
if(_490){
_490(_498,data[i].src);
}
_491.appendChild(_498);
}
return _491;
}});
dojo.charting.Plotters["Default"]=dojo.charting.Plotters.Line;
}
dojo.provide("dojo.charting.vml.Plotters");
if(dojo.render.vml.capable){
dojo.mixin(dojo.charting.Plotters,{_group:function(_499){
var _49a=document.createElement("div");
_49a.style.position="absolute";
_49a.style.top="0px";
_49a.style.left="0px";
_49a.style.width=_499.size.width+"px";
_49a.style.height=_499.size.height+"px";
return _49a;
},Bar:function(_49b,plot,_49d,_49e){
var area=_49b.getArea();
var _4a0=dojo.charting.Plotters._group(_49b);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_49d);
data.push(tmp);
}
var _4a5=8;
var _4a6=data[0].length;
if(_4a6==0){
return _4a0;
}
var _4a7=((area.right-area.left)-(_4a5*(_4a6-1)))/_4a6;
var _4a8=Math.round(_4a7/n);
var _4a9=plot.axisY.getCoord(plot.axisX.origin,_49b,plot);
for(var i=0;i<_4a6;i++){
var _4aa=area.left+(_4a7*i)+(_4a5*i);
for(var j=0;j<n;j++){
var _4ac=data[j][i].y;
var yA=_4a9;
var x=_4aa+(_4a8*j);
var y=plot.axisY.getCoord(_4ac,_49b,plot);
var h=Math.abs(yA-y);
if(_4ac<plot.axisX.origin){
yA=y;
y=_4a9;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=_4a8+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_49e){
_49e(bar,data[j][i].src);
}
_4a0.appendChild(bar);
}
}
return _4a0;
},HorizontalBar:function(_4b3,plot,_4b5,_4b6){
var area=_4b3.getArea();
var _4b8=dojo.charting.Plotters._group(_4b3);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4b5);
data.push(tmp);
}
var _4bd=6;
var _4be=data[0].length;
if(_4be==0){
return _4b8;
}
var h=((area.bottom-area.top)-(_4bd*(_4be-1)))/_4be;
var barH=h/n;
var _4c1=plot.axisX.getCoord(0,_4b3,plot);
for(var i=0;i<_4be;i++){
var _4c2=area.top+(h*i)+(_4bd*i);
for(var j=0;j<n;j++){
var _4c4=data[j][i].y;
var y=_4c2+(barH*j);
var xA=_4c1;
var x=plot.axisX.getCoord(_4c4,_4b3,plot);
var w=Math.abs(x-xA);
if(_4c4>0){
x=_4c1;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=xA+"px";
bar.style.width=w+"px";
bar.style.height=barH+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_4b6){
_4b6(bar,data[j][i].src);
}
_4b8.appendChild(bar);
}
}
var _4bd=4;
var n=plot.series.length;
var h=((area.bottom-area.top)-(_4bd*(n-1)))/n;
var _4c1=plot.axisX.getCoord(0,_4b3,plot);
for(var i=0;i<n;i++){
var _4cb=plot.series[i];
var data=_4cb.data.evaluate(_4b5);
var y=area.top+(h*i)+(_4bd*i);
var _4c4=data[data.length-1].y;
var xA=_4c1;
var x=plot.axisX.getCoord(_4c4,_4b3,plot);
var w=Math.abs(xA-x);
if(_4c4>0){
xA=x;
x=_4c1;
}
}
return _4b8;
},Gantt:function(_4cc,plot,_4ce,_4cf){
var area=_4cc.getArea();
var _4d1=dojo.charting.Plotters._group(_4cc);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4ce);
data.push(tmp);
}
var _4d6=2;
var _4d7=data[0].length;
if(_4d7==0){
return _4d1;
}
var h=((area.bottom-area.top)-(_4d6*(_4d7-1)))/_4d7;
var barH=h/n;
for(var i=0;i<_4d7;i++){
var _4da=area.top+(h*i)+(_4d6*i);
for(var j=0;j<n;j++){
var high=data[j][i].high;
var low=data[j][i].low;
if(low>high){
var t=high;
high=low;
low=t;
}
var x=plot.axisX.getCoord(low,_4cc,plot);
var w=plot.axisX.getCoord(high,_4cc,plot)-x;
var y=_4da+(barH*j);
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=barH+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_4cf){
_4cf(bar,data[j][i].src);
}
_4d1.appendChild(bar);
}
}
return _4d1;
},StackedArea:function(_4e4,plot,_4e6,_4e7){
var area=_4e4.getArea();
var _4e9=dojo.charting.Plotters._group(_4e4);
var n=plot.series.length;
var data=[];
var _4ec=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4e6);
for(var j=0;j<tmp.length;j++){
if(i==0){
_4ec.push(tmp[j].y);
}else{
_4ec[j]+=tmp[j].y;
}
tmp[j].y=_4ec[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[i][0].series.color);
path.setAttribute("fillcolor",data[i][0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _4f1=document.createElement("v:stroke");
_4f1.setAttribute("opacity","0.8");
path.appendChild(_4f1);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _4f5=data[i];
var x=Math.round(plot.axisX.getCoord(_4f5[j].x,_4e4,plot));
var y=Math.round(plot.axisY.getCoord(_4f5[j].y,_4e4,plot));
if(j==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",_4f5[j].series.color);
c.setAttribute("fillcolor",_4f5[j].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_4e9.appendChild(c);
if(_4e7){
_4e7(c,data[j].src);
}
}
if(i==0){
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4e4,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0][0].x,_4e4,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4e4,plot)));
}else{
var _4f5=data[i-1];
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_4f5[_4f5.length-1].y,_4e4,plot)));
for(var j=_4f5.length-2;j>=0;j--){
var x=Math.round(plot.axisX.getCoord(_4f5[j].x,_4e4,plot));
var y=Math.round(plot.axisY.getCoord(_4f5[j].y,_4e4,plot));
cmd.push("l");
cmd.push(x+","+y);
}
}
path.setAttribute("path",cmd.join(" ")+" x e");
_4e9.appendChild(path);
}
return _4e9;
},StackedCurvedArea:function(_4fb,plot,_4fd,_4fe){
var _4ff=3;
var area=_4fb.getArea();
var _501=dojo.charting.Plotters._group(_4fb);
var n=plot.series.length;
var data=[];
var _504=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4fd);
for(var j=0;j<tmp.length;j++){
if(i==0){
_504.push(tmp[j].y);
}else{
_504[j]+=tmp[j].y;
}
tmp[j].y=_504[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[i][0].series.color);
path.setAttribute("fillcolor",data[i][0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _509=document.createElement("v:stroke");
_509.setAttribute("opacity","0.8");
path.appendChild(_509);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _50d=data[i];
var x=Math.round(plot.axisX.getCoord(_50d[j].x,_4fb,plot));
var y=Math.round(plot.axisY.getCoord(_50d[j].y,_4fb,plot));
if(j==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _510=Math.round(plot.axisX.getCoord(_50d[j-1].x,_4fb,plot));
var _511=Math.round(plot.axisY.getCoord(_50d[j-1].y,_4fb,plot));
var dx=x-_510;
var dy=y-_511;
cmd.push("c");
var cx=Math.round((x-(_4ff-1)*(dx/_4ff)));
cmd.push(cx+","+_511);
cx=Math.round((x-(dx/_4ff)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",_50d[j].series.color);
c.setAttribute("fillcolor",_50d[j].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_501.appendChild(c);
if(_4fe){
_4fe(c,data[j].src);
}
}
if(i==0){
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4fb,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0][0].x,_4fb,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4fb,plot)));
}else{
var _50d=data[i-1];
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_50d[_50d.length-1].y,_4fb,plot)));
for(var j=_50d.length-2;j>=0;j--){
var x=Math.round(plot.axisX.getCoord(_50d[j].x,_4fb,plot));
var y=Math.round(plot.axisY.getCoord(_50d[j].y,_4fb,plot));
var _510=Math.round(plot.axisX.getCoord(_50d[j+1].x,_4fb,plot));
var _511=Math.round(plot.axisY.getCoord(_50d[j+1].y,_4fb,plot));
var dx=x-_510;
var dy=y-_511;
cmd.push("c");
var cx=Math.round((x-(_4ff-1)*(dx/_4ff)));
cmd.push(cx+","+_511);
cx=Math.round((x-(dx/_4ff)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
}
path.setAttribute("path",cmd.join(" ")+" x e");
_501.appendChild(path);
}
return _501;
},DataBar:function(data,_519,plot,_51b){
var area=_519.getArea();
var _51d=dojo.charting.Plotters._group(_519);
var n=data.length;
var w=(area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower);
var _520=plot.axisY.getCoord(plot.axisX.origin,_519,plot);
for(var i=0;i<n;i++){
var _522=data[i].y;
var yA=_520;
var x=plot.axisX.getCoord(data[i].x,_519,plot)-(w/2)+1;
var y=plot.axisY.getCoord(_522,_519,plot);
var h=Math.abs(yA-y);
if(_522<plot.axisX.origin){
yA=y;
y=_520;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_51b){
_51b(bar,data[i].src);
}
_51d.appendChild(bar);
}
return _51d;
},Line:function(data,_52a,plot,_52c){
var area=_52a.getArea();
var _52e=dojo.charting.Plotters._group(_52a);
if(data.length==0){
return _52e;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","2px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor","none");
path.setAttribute("filled","false");
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _530=document.createElement("v:stroke");
_530.setAttribute("opacity","0.8");
path.appendChild(_530);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_52a,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_52a,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_52e.appendChild(c);
if(_52c){
_52c(c,data[i].src);
}
}
path.setAttribute("path",cmd.join(" ")+" e");
_52e.appendChild(path);
return _52e;
},CurvedLine:function(data,_53a,plot,_53c){
var _53d=3;
var area=_53a.getArea();
var _53f=dojo.charting.Plotters._group(_53a);
if(data.length==0){
return _53f;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","2px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor","none");
path.setAttribute("filled","false");
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _541=document.createElement("v:stroke");
_541.setAttribute("opacity","0.8");
path.appendChild(_541);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_53a,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_53a,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _547=Math.round(plot.axisX.getCoord(data[i-1].x,_53a,plot));
var _548=Math.round(plot.axisY.getCoord(data[i-1].y,_53a,plot));
var dx=x-_547;
var dy=y-_548;
cmd.push("c");
var cx=Math.round((x-(_53d-1)*(dx/_53d)));
cmd.push(cx+","+_548);
cx=Math.round((x-(dx/_53d)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_53f.appendChild(c);
if(_53c){
_53c(c,data[i].src);
}
}
path.setAttribute("path",cmd.join(" ")+" e");
_53f.appendChild(path);
return _53f;
},Area:function(data,_550,plot,_552){
var area=_550.getArea();
var _554=dojo.charting.Plotters._group(_550);
if(data.length==0){
return _554;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor",data[0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _556=document.createElement("v:stroke");
_556.setAttribute("opacity","0.8");
path.appendChild(_556);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_550,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_550,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_554.appendChild(c);
if(_552){
_552(c,data[i].src);
}
}
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_550,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0].x,_550,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_550,plot)));
path.setAttribute("path",cmd.join(" ")+" x e");
_554.appendChild(path);
return _554;
},CurvedArea:function(data,_561,plot,_563){
var _564=3;
var area=_561.getArea();
var _566=dojo.charting.Plotters._group(_561);
if(data.length==0){
return _566;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor",data[0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _568=document.createElement("v:stroke");
_568.setAttribute("opacity","0.8");
path.appendChild(_568);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_561,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_561,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _56f=Math.round(plot.axisX.getCoord(data[i-1].x,_561,plot));
var _570=Math.round(plot.axisY.getCoord(data[i-1].y,_561,plot));
var dx=x-_56f;
var dy=y-_570;
cmd.push("c");
var cx=Math.round((x-(_564-1)*(dx/_564)));
cmd.push(cx+","+_570);
cx=Math.round((x-(dx/_564)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_566.appendChild(c);
if(_563){
_563(c,data[i].src);
}
}
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_561,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0].x,_561,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_561,plot)));
path.setAttribute("path",cmd.join(" ")+" x e");
_566.appendChild(path);
return _566;
},HighLow:function(data,_578,plot,_57a){
var area=_578.getArea();
var _57c=dojo.charting.Plotters._group(_578);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var x=plot.axisX.getCoord(data[i].x,_578,plot)-(w/2);
var y=plot.axisY.getCoord(high,_578,plot);
var h=plot.axisY.getCoord(low,_578,plot)-y;
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_57a){
_57a(bar,data[i].src);
}
_57c.appendChild(bar);
}
return _57c;
},HighLowClose:function(data,_58a,plot,_58c){
var area=_58a.getArea();
var _58e=dojo.charting.Plotters._group(_58a);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_58a,plot)-(w/2);
var y=plot.axisY.getCoord(high,_58a,plot);
var h=plot.axisY.getCoord(low,_58a,plot)-y;
var _59a=plot.axisY.getCoord(c,_58a,plot);
var g=document.createElement("div");
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
g.appendChild(bar);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",x+"px,"+_59a+"px");
line.setAttribute("to",(x+w+(part*2)-2)+"px,"+_59a+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
if(_58c){
_58c(g,data[i].src);
}
_58e.appendChild(g);
}
return _58e;
},HighLowOpenClose:function(data,_5a2,plot,_5a4){
var area=_5a2.getArea();
var _5a6=dojo.charting.Plotters._group(_5a2);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var o=data[i].open;
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_5a2,plot)-(w/2);
var y=plot.axisY.getCoord(high,_5a2,plot);
var h=plot.axisY.getCoord(low,_5a2,plot)-y;
var open=plot.axisY.getCoord(o,_5a2,plot);
var _5b4=plot.axisY.getCoord(c,_5a2,plot);
var g=document.createElement("div");
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
g.appendChild(bar);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",(x-(part*2))+"px,"+open+"px");
line.setAttribute("to",(x+w-2)+"px,"+open+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",x+"px,"+_5b4+"px");
line.setAttribute("to",(x+w+(part*2)-2)+"px,"+_5b4+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
if(_5a4){
_5a4(g,data[i].src);
}
_5a6.appendChild(g);
}
return _5a6;
},Scatter:function(data,_5bc,plot,_5be){
var r=6;
var mod=r/2;
var area=_5bc.getArea();
var _5c2=dojo.charting.Plotters._group(_5bc);
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_5bc,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_5bc,plot));
var _5c6=document.createElement("v:rect");
_5c6.setAttribute("strokecolor",data[i].series.color);
_5c6.setAttribute("fillcolor",data[i].series.color);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
_5c6.appendChild(fill);
var s=_5c6.style;
s.position="absolute";
s.rotation="45";
s.top=(y-mod)+"px";
s.left=(x-mod)+"px";
s.width=r+"px";
s.height=r+"px";
_5c2.appendChild(_5c6);
if(_5be){
_5be(_5c6,data[i].src);
}
}
return _5c2;
},Bubble:function(data,_5ca,plot,_5cc){
var _5cd=1;
var area=_5ca.getArea();
var _5cf=dojo.charting.Plotters._group(_5ca);
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_5ca,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_5ca,plot));
if(i==0){
var raw=data[i].size;
var dy=plot.axisY.getCoord(data[i].y+raw,_5ca,plot)-y;
_5cd=dy/raw;
}
if(_5cd<1){
_5cd=1;
}
var r=(data[i].size/2)*_5cd;
var _5d6=document.createElement("v:oval");
_5d6.setAttribute("strokecolor",data[i].series.color);
_5d6.setAttribute("fillcolor",data[i].series.color);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
_5d6.appendChild(fill);
var s=_5d6.style;
s.position="absolute";
s.rotation="45";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_5cf.appendChild(_5d6);
if(_5cc){
_5cc(_5d6,data[i].src);
}
}
return _5cf;
}});
dojo.charting.Plotters["Default"]=dojo.charting.Plotters.Line;
}
dojo.provide("dojo.charting.Series");
dojo.charting.Series=function(_5d9){
var args=_5d9||{length:1};
this.dataSource=args.dataSource||null;
this.bindings={};
this.color=args.color;
this.label=args.label;
if(args.bindings){
for(var p in args.bindings){
this.addBinding(p,args.bindings[p]);
}
}
};
dojo.extend(dojo.charting.Series,{bind:function(src,_5dd){
this.dataSource=src;
this.bindings=_5dd;
},addBinding:function(name,_5df){
this.bindings[name]=_5df;
},evaluate:function(_5e0){
var ret=[];
var a=this.dataSource.getData();
var l=a.length;
var _5e4=0;
var end=l;
if(_5e0){
if(_5e0.between){
for(var i=0;i<l;i++){
var fld=this.dataSource.getField(a[i],_5e0.between.field);
if(fld>=_5e0.between.low&&fld<=_5e0.between.high){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
ret.push(o);
}
}
}else{
if(_5e0.from||_5e0.length){
if(_5e0.from){
_5e4=Math.max(_5e0.from,0);
if(_5e0.to){
end=Math.min(_5e0.to,end);
}
}else{
if(_5e0.length<0){
_5e4=Math.max((end+length),0);
}else{
end=Math.min((_5e4+length),end);
}
}
for(var i=_5e4;i<end;i++){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
ret.push(o);
}
}
}
}else{
for(var i=_5e4;i<end;i++){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
ret.push(o);
}
}
if(ret.length>0&&typeof (ret[0].x)!="undefined"){
ret.sort(function(a,b){
if(a.x>b.x){
return 1;
}
if(a.x<b.x){
return -1;
}
return 0;
});
}
return ret;
},trends:{createRange:function(_5ec,len){
var idx=_5ec.length-1;
var _5ef=(len||_5ec.length);
return {"index":idx,"length":_5ef,"start":Math.max(idx-_5ef,0)};
},mean:function(_5f0,len){
var _5f2=this.createRange(_5f0,len);
if(_5f2.index<0){
return 0;
}
var _5f3=0;
var _5f4=0;
for(var i=_5f2.index;i>=_5f2.start;i--){
_5f3+=_5f0[i].y;
_5f4++;
}
_5f3/=Math.max(_5f4,1);
return _5f3;
},variance:function(_5f6,len){
var _5f8=this.createRange(_5f6,len);
if(_5f8.index<0){
return 0;
}
var _5f9=0;
var _5fa=0;
var _5fb=0;
for(var i=_5f8.index;i>=_5f8.start;i--){
_5f9+=_5f6[i].y;
_5fa+=Math.pow(_5f6[i].y,2);
_5fb++;
}
return (_5fa/_5fb)-Math.pow(_5f9/_5fb,2);
},standardDeviation:function(_5fd,len){
return Math.sqrt(this.getVariance(_5fd,len));
},max:function(_5ff,len){
var _601=this.createRange(_5ff,len);
if(_601.index<0){
return 0;
}
var max=Number.MIN_VALUE;
for(var i=_601.index;i>=_601.start;i--){
max=Math.max(_5ff[i].y,max);
}
return max;
},min:function(_604,len){
var _606=this.createRange(_604,len);
if(_606.index<0){
return 0;
}
var min=Number.MAX_VALUE;
for(var i=_606.index;i>=_606.start;i--){
min=Math.min(_604[i].y,min);
}
return min;
},median:function(_609,len){
var _60b=this.createRange(_609,len);
if(_60b.index<0){
return 0;
}
var a=[];
for(var i=_60b.index;i>=_60b.start;i--){
var b=false;
for(var j=0;j<a.length;j++){
if(_609[i].y==a[j]){
b=true;
break;
}
}
if(!b){
a.push(_609[i].y);
}
}
a.sort();
if(a.length>0){
return a[Math.ceil(a.length/2)];
}
return 0;
},mode:function(_610,len){
var _612=this.createRange(_610,len);
if(_612.index<0){
return 0;
}
var o={};
var ret=0;
var _615=Number.MIN_VALUE;
for(var i=_612.index;i>=_612.start;i--){
if(!o[_610[i].y]){
o[_610[i].y]=1;
}else{
o[_610[i].y]++;
}
}
for(var p in o){
if(_615<o[p]){
_615=o[p];
ret=p;
}
}
return ret;
}}});
dojo.provide("dojo.charting.Plot");
dojo.charting.RenderPlotSeries={Singly:"single",Grouped:"grouped"};
dojo.charting.Plot=function(_618,_619,_61a){
var id="dojo-charting-plot-"+dojo.charting.Plot.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.axisX=null;
this.axisY=null;
this.series=[];
this.dataNode=null;
this.renderType=dojo.charting.RenderPlotSeries.Singly;
if(_618){
this.setAxis(_618,"x");
}
if(_619){
this.setAxis(_619,"y");
}
if(_61a){
for(var i=0;i<_61a.length;i++){
this.addSeries(_61a[i]);
}
}
};
dojo.charting.Plot.count=0;
dojo.extend(dojo.charting.Plot,{addSeries:function(_61e,_61f){
if(_61e.plotter){
this.series.push(_61e);
}else{
this.series.push({data:_61e,plotter:_61f||dojo.charting.Plotters["Default"]});
}
},setAxis:function(axis,_621){
if(_621.toLowerCase()=="x"){
this.axisX=axis;
}else{
if(_621.toLowerCase()=="y"){
this.axisY=axis;
}
}
},getRanges:function(){
var xmin,xmax,ymin,ymax;
xmin=ymin=Number.MAX_VALUE;
xmax=ymax=Number.MIN_VALUE;
for(var i=0;i<this.series.length;i++){
var _627=this.series[i].data.evaluate();
for(var j=0;j<_627.length;j++){
var comp=_627[j];
xmin=Math.min(comp.x,xmin);
ymin=Math.min(comp.y,ymin);
xmax=Math.max(comp.x,xmax);
ymax=Math.max(comp.y,ymax);
}
}
return {x:{upper:xmax,lower:xmin},y:{upper:ymax,lower:ymin},toString:function(){
return "[ x:"+xmax+" - "+xmin+", y:"+ymax+" - "+ymin+"]";
}};
},destroy:function(){
var node=this.dataNode;
while(node&&node.childNodes&&node.childNodes.length>0){
node.removeChild(node.childNodes[0]);
}
this.dataNode=null;
}});
dojo.provide("dojo.charting.PlotArea");
dojo.charting.PlotArea=function(){
var id="dojo-charting-plotarea-"+dojo.charting.PlotArea.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.areaType="standard";
this.plots=[];
this.size={width:600,height:400};
this.padding={top:10,right:10,bottom:20,left:20};
this.nodes={main:null,area:null,background:null,axes:null,plots:null};
this._color={h:140,s:120,l:120,step:27};
};
dojo.charting.PlotArea.count=0;
dojo.extend(dojo.charting.PlotArea,{nextColor:function(){
var rgb=dojo.gfx.color.hsl2rgb(this._color.h,this._color.s,this._color.l);
this._color.h=(this._color.h+this._color.step)%360;
while(this._color.h<140){
this._color.h+=this._color.step;
}
return dojo.gfx.color.rgb2hex(rgb[0],rgb[1],rgb[2]);
},getArea:function(){
return {left:this.padding.left,right:this.size.width-this.padding.right,top:this.padding.top,bottom:this.size.height-this.padding.bottom,toString:function(){
var a=[this.top,this.right,this.bottom,this.left];
return "["+a.join()+"]";
}};
},getAxes:function(){
var axes={};
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
axes[plot.axisX.getId()]={axis:plot.axisX,drawAgainst:plot.axisY,plot:plot,plane:"x"};
axes[plot.axisY.getId()]={axis:plot.axisY,drawAgainst:plot.axisX,plot:plot,plane:"y"};
}
return axes;
},getLegendInfo:function(){
var a=[];
for(var i=0;i<this.plots.length;i++){
for(var j=0;j<this.plots[i].series.length;j++){
var data=this.plots[i].series[j].data;
a.push({label:data.label,color:data.color});
}
}
return a;
},setAxesRanges:function(){
var _636={};
var axes={};
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
var _636=plot.getRanges();
var x=_636.x;
var y=_636.y;
var ax,ay;
if(!axes[plot.axisX.getId()]){
axes[plot.axisX.getId()]=plot.axisX;
_636[plot.axisX.getId()]={upper:x.upper,lower:x.lower};
}
ax=_636[plot.axisX.getId()];
ax.upper=Math.max(ax.upper,x.upper);
ax.lower=Math.min(ax.lower,x.lower);
if(!axes[plot.axisY.getId()]){
axes[plot.axisY.getId()]=plot.axisY;
_636[plot.axisY.getId()]={upper:y.upper,lower:y.lower};
}
ay=_636[plot.axisY.getId()];
ay.upper=Math.max(ay.upper,y.upper);
ay.lower=Math.min(ay.lower,y.lower);
}
for(var p in axes){
axes[p].range=_636[p];
}
},render:function(_63f,_640){
if(!this.nodes.main||!this.nodes.area||!this.nodes.background||!this.nodes.plots||!this.nodes.axes){
this.initialize();
}
this.resize();
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
if(plot.dataNode){
this.nodes.plots.removeChild(plot.dataNode);
}
var _643=this.initializePlot(plot);
switch(plot.renderType){
case dojo.charting.RenderPlotSeries.Grouped:
if(plot.series[0]){
_643.appendChild(plot.series[0].plotter(this,plot,_63f,_640));
}
break;
case dojo.charting.RenderPlotSeries.Singly:
default:
for(var j=0;j<plot.series.length;j++){
var _645=plot.series[j];
var data=_645.data.evaluate(_63f);
_643.appendChild(_645.plotter(data,this,plot,_640));
}
}
this.nodes.plots.appendChild(_643);
}
},destroy:function(){
for(var i=0;i<this.plots.length;i++){
this.plots[i].destroy();
}
for(var p in this.nodes){
var node=this.nodes[p];
if(!node){
continue;
}
if(!node.childNodes){
continue;
}
while(node.childNodes.length>0){
node.removeChild(node.childNodes[0]);
}
this.nodes[p]=null;
}
}});
dojo.provide("dojo.charting.svg.PlotArea");
if(dojo.render.svg.capable){
dojo.extend(dojo.charting.PlotArea,{resize:function(){
var area=this.getArea();
this.nodes.area.setAttribute("width",this.size.width);
this.nodes.area.setAttribute("height",this.size.height);
var rect=this.nodes.area.getElementsByTagName("rect")[0];
rect.setAttribute("x",area.left);
rect.setAttribute("y",area.top);
rect.setAttribute("width",area.right-area.left);
rect.setAttribute("height",area.bottom-area.top);
this.nodes.background.setAttribute("width",this.size.width);
this.nodes.background.setAttribute("height",this.size.height);
if(this.nodes.plots){
this.nodes.area.removeChild(this.nodes.plots);
this.nodes.plots=null;
}
this.nodes.plots=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.plots.setAttribute("id",this.getId()+"-plots");
this.nodes.plots.setAttribute("style","clip-path:url(#"+this.getId()+"-clip);");
this.nodes.area.appendChild(this.nodes.plots);
for(var i=0;i<this.plots.length;i++){
this.nodes.plots.appendChild(this.initializePlot(this.plots[i]));
}
if(this.nodes.axes){
this.nodes.area.removeChild(this.nodes.axes);
this.nodes.axes=null;
}
this.nodes.axes=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.axes.setAttribute("id",this.getId()+"-axes");
this.nodes.area.appendChild(this.nodes.axes);
var axes=this.getAxes();
for(var p in axes){
var obj=axes[p];
this.nodes.axes.appendChild(obj.axis.initialize(this,obj.plot,obj.drawAgainst,obj.plane));
}
},initializePlot:function(plot){
plot.destroy();
plot.dataNode=document.createElementNS(dojo.svg.xmlns.svg,"g");
plot.dataNode.setAttribute("id",plot.getId());
return plot.dataNode;
},initialize:function(){
this.destroy();
this.nodes.main=document.createElement("div");
this.nodes.area=document.createElementNS(dojo.svg.xmlns.svg,"svg");
this.nodes.area.setAttribute("id",this.getId());
this.nodes.main.appendChild(this.nodes.area);
var defs=document.createElementNS(dojo.svg.xmlns.svg,"defs");
var clip=document.createElementNS(dojo.svg.xmlns.svg,"clipPath");
clip.setAttribute("id",this.getId()+"-clip");
var rect=document.createElementNS(dojo.svg.xmlns.svg,"rect");
clip.appendChild(rect);
defs.appendChild(clip);
this.nodes.area.appendChild(defs);
this.nodes.background=document.createElementNS(dojo.svg.xmlns.svg,"rect");
this.nodes.background.setAttribute("id",this.getId()+"-background");
this.nodes.background.setAttribute("fill","#fff");
this.nodes.area.appendChild(this.nodes.background);
this.resize();
return this.nodes.main;
}});
}
dojo.provide("dojo.charting.vml.PlotArea");
if(dojo.render.vml.capable){
dojo.extend(dojo.charting.PlotArea,{resize:function(){
var a=this.getArea();
this.nodes.area.style.width=this.size.width+"px";
this.nodes.area.style.height=this.size.height+"px";
this.nodes.background.style.width=this.size.width+"px";
this.nodes.background.style.height=this.size.height+"px";
this.nodes.plots.width=this.size.width+"px";
this.nodes.plots.height=this.size.height+"px";
this.nodes.plots.style.clip="rect("+a.top+" "+a.right+" "+a.bottom+" "+a.left+")";
if(this.nodes.axes){
this.nodes.area.removeChild(this.nodes.axes);
}
var axes=this.nodes.axes=document.createElement("div");
axes.id=this.getId()+"-axes";
this.nodes.area.appendChild(axes);
var ax=this.getAxes();
for(var p in ax){
var obj=ax[p];
axes.appendChild(obj.axis.initialize(this,obj.plot,obj.drawAgainst,obj.plane));
}
},initializePlot:function(plot){
plot.destroy();
plot.dataNode=document.createElement("div");
plot.dataNode.id=plot.getId();
return plot.dataNode;
},initialize:function(){
this.destroy();
var main=this.nodes.main=document.createElement("div");
var area=this.nodes.area=document.createElement("div");
area.id=this.getId();
area.style.position="absolute";
main.appendChild(area);
var bg=this.nodes.background=document.createElement("div");
bg.id=this.getId()+"-background";
bg.style.position="absolute";
bg.style.top="0px";
bg.style.left="0px";
bg.style.backgroundColor="#fff";
area.appendChild(bg);
var a=this.getArea();
var _65e=this.nodes.plots=document.createElement("div");
_65e.id=this.getId()+"-plots";
_65e.style.position="absolute";
_65e.style.top="0px";
_65e.style.left="0px";
area.appendChild(_65e);
for(var i=0;i<this.plots.length;i++){
_65e.appendChild(this.initializePlot(this.plots[i]));
}
this.resize();
return main;
}});
}
dojo.provide("dojo.charting.Chart");
dojo.charting.Chart=function(node,_661,_662){
this.node=node||null;
this.title=_661||"Chart";
this.description=_662||"";
this.plotAreas=[];
};
dojo.extend(dojo.charting.Chart,{addPlotArea:function(obj,_664){
if(obj.x!=null&&obj.left==null){
obj.left=obj.x;
}
if(obj.y!=null&&obj.top==null){
obj.top=obj.y;
}
this.plotAreas.push(obj);
if(_664){
this.render();
}
},onInitialize:function(_665){
},onRender:function(_666){
},onDestroy:function(_667){
},initialize:function(){
if(!this.node){
dojo.raise("dojo.charting.Chart.initialize: there must be a root node defined for the Chart.");
}
this.destroy();
this.render();
this.onInitialize(this);
},render:function(){
if(this.node.style.position!="absolute"){
this.node.style.position="relative";
}
for(var i=0;i<this.plotAreas.length;i++){
var area=this.plotAreas[i].plotArea;
var node=area.initialize();
node.style.position="absolute";
node.style.top=this.plotAreas[i].top+"px";
node.style.left=this.plotAreas[i].left+"px";
this.node.appendChild(node);
area.render();
}
},destroy:function(){
for(var i=0;i<this.plotAreas.length;i++){
this.plotAreas[i].plotArea.destroy();
}
while(this.node&&this.node.childNodes&&this.node.childNodes.length>0){
this.node.removeChild(this.node.childNodes[0]);
}
}});

